SystemOrganization addCategory: #'XpProcess-Model'!
SystemOrganization addCategory: #'XpProcess-Components'!
SystemOrganization addCategory: #'XpProcess-Tests'!
SystemOrganization addCategory: #'XpProcess-Login'!
SystemOrganization addCategory: #'XpProcess-Database'!
SystemOrganization addCategory: #'XpProcess-Support'!

WATask subclass: #XpRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Components'!

!XpRootTask commentStamp: 'rga 3/19/2009 17:08' prior: 0!
A XpRootTask is a WATask, so no rendering and a  'go' method.

Instance Variables  <none>

About de #go method:
	XpLoginComponent can yield to 2 responses or results:
		#registerUser  <when somebody hit the 'inscription button'> 
		#user  <when the user loggedIn successfully>

	XpRegisterComponent give also two results:
		#user  <when the user registered successfully>
		'true' <when someone hit the 'cancel button'!

!XpRootTask class methodsFor: 'testing' stamp: 'rga 3/9/2009 14:54'!
canBeRoot
	^ 	true! !

!XpRootTask class methodsFor: 'testing' stamp: 'RGA 10/29/2014 13:13'!
initialize
"XpRootTask initialize"

| application maSession |
	self flag: #modifierSiMagma.	
	maSession := XpSession new.
	application := WAAdmin register: self asApplicationAt: 'XpProcess'	.
	application preferenceAt: #sessionClass put: maSession.
! !

!XpRootTask methodsFor: 'processing' stamp: 'rga 1/6/2015 17:49'!
go
	| loginAnswer user anXpProcess |
	loginAnswer := self call: XpLoginComponent new.
	loginAnswer = #registerUser
		ifTrue: [user := self call: XpRegisterComponent new]
		ifFalse: [user := loginAnswer].
	user
		ifNotNil: ["user = (from a successfull registration) or (from a
			successfull login)"
			self session login: user.
			anXpProcess := XpProcessComponent new.	
"			anXpProcess resetProject .
"			self show: anXpProcess].
! !

!XpRootTask methodsFor: 'initialization' stamp: 'RGA 10/25/2014 23:41'!
initialize
	super initialize.
! !

WAFileLibrary subclass: #XpLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Database'!

!XpLibrary class methodsFor: 'as yet unclassified' stamp: 'rga 3/23/2009 18:00'!
applicationName
	^ 'GDX - Gestion du Dveloppement XP'! !

!XpLibrary class methodsFor: 'as yet unclassified' stamp: 'RGA 11/21/2014 19:50'!
info
	^ '  Faites le suivi de votre projet eXtreme Programming avec cette application dveloppe avec 
	 Squeak 4.4  et  Seaside 3.0 .   
	- Pour le moment l''image de Squeak sert de Base de Donnes.
	- Cette application n''est pas ncessairement utile   :)    Elle n''est qu''un moyen d''apprendre
	Seaside et Magritte.'! !

!XpLibrary methodsFor: 'accessing' stamp: 'rga 4/2/2009 17:55'!
selectorsToInclude
	^ #(#xpCss )! !

!XpLibrary methodsFor: 'accessing' stamp: 'RGA 11/24/2014 16:51'!
xpCss
	^ '	/*   
		"#" sont des selecteurs de division de page .
		"BODY" sont des selecteurs de type .
		".class-name" sont des selecteurs de classe : 
			exemple:   ".foo"    . */
h1 {
	padding: 1.0em;
	text-align: left ;
	font-size: 1.3em; 
	color: yellow;	
	background-color: darkblue;
	} 
h2, h3, h4, h5, h6 {
	margin: 0px  0px;
	padding:10px 0px;
	}
div, span, table, thead, tfoot, tr, td, th, p, ul, ol, dl, li, dt, dd, blockquote, a, img, br, h1, h2, h3, h4, h5, h6, hr, address, del, ins, pre, object, embed, q, sub, sup, form, label, abbr, acronym, cite, cc, dfn, em, strong, b, i, kbd, samp, var, iframe {
	border:0 solid #9E9A91;
	list-style-type:none;
	padding:0;
	border-collapse: collapse;
	}add
textArea {
	background-color: yellow;
	width: 228px;
	}
table  {
	border: 0 solid #9E9A91;
	margin-left: 150px;
	margin-right: 1em;
	width:82%;
	}
tr , even  {
	background-color: lightblue; 
	} 
th  {	
	font:  verdana;
	color: darkblue ;
	font-size: 1em;
	border-color: darkblue;
	padding: 0em 0.5em;
	}
td { 
	border-style:solid; 
	border-width: 1px; 
	font:  verdana;
	background-color: white ;
	padding: 0.1em 0.4em 0.1em;
	}
.presentation {
	position: relative;
	margin-left: 22px;
	margin-top: 22px;
	border-radius: 10px; 
	border-width: thick;
	background-color: lightblue ;
	border-color: darkblue;
	margin-right: 2em;
	padding: 0.5em ;
	height: auto;
	width: 50%;
	font-size: 1em;
	}
.boutonAjouter  {
	margin-left: 120px;
	}
.presentation .info {
	background-color: yellow ;
	margin: 1.5em;
	padding: 1.5em ;
	}

.menu  a	{
	float: left ;
	color: red;
	font-style: italic;
	line-height:1.8em;
	}
.menu {
	position: absolute;
	top: 100px;
	left: -7px;
	border: 1px solid blue;
	border-radius: 10px; 
	width: 4.8em;
	line-height:1.8em;
	margin: 1em;
	padding: 1.5em;
	background-color: #FFFF60;
	}
.menuCreation {
	left: 0px;
	border: 1px solid blue;
	border-radius: 10px; 
	width: 84%;
	padding: 0 1em 0 7em;
	background-color: lightgreen
	}
.menuCreation  a	{
	color: red;
	padding: 0 1em ;
	font-style: italic;
	line-height:2em;
	}
.registerComponent {
	position: relative;
	margin-left: 120px;
	margin-top: 22px;
	border-radius: 10px; 
	border-width: thick;
	background-color: yellow ;
	border-color: darkblue;
	padding: 0.5em ;
	height: auto;
	width: 40%;
	font-size: 1em;
	}
.center  {
	margin-top: 14px;
	text-align: center;
	font-size: 1.5em;
	color: red;
	}
.report  {
	margin-top: 8px;
	}
.registerComponent table {
	border-color: darkblue;
	margin-top: 0em;
	margin-left: 1em;
	padding: 0.5em ;
	height: auto;
	width: 90%;
	font-size: 1em;
	}
.reportB {
	padding: 0.5em ;
	width: 44%;
	}
.reportD {
	padding: 0.5em ;
	margin-left: 150px;
	margin-right: 1em;
	width:82%;
	}
'! !

!ChronologyConstants class methodsFor: '*XpProcess-' stamp: 'rga 3/9/2009 14:35'!
initializeForFrench
	"ChronologyConstants initialize" 	SqueakEpoch := 2415386. 		"Julian day number of 1 Jan 1901" 
	SecondsInDay := 86400.
	SecondsInHour := 3600.
	SecondsInMinute := 60.
	NanosInSecond := 10 raisedTo: 9.
	NanosInMillisecond := 10 raisedTo: 6.
	DayNames := #(Dimanche Lundi Mardi Mercredi Jeudi Vendredi Samedi "Sunday Monday Tuesday Wednesday Thursday Friday Saturday").
		
	MonthNames := #(Janvier Fevrier Mars Avril Mai Juin Juillet Aout Septembre Octobre Novembre Decembre "January February March April May June July
 			August September October November December").
	DaysInMonth := #(31 28 31 30 31 30 31 31 30 31 30 31).
! !

Model subclass: #XpCommun
	instanceVariableNames: 'id hisName note owner project history start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpCommun commentStamp: 'RGA 11/27/2014 19:00' prior: 0!
A XpCommun is xxxxxxxxx.

Instance Variables
	endDate:		<Object>
	hisName:		<aString>
	history:		<Object>
	id:		<Object>
	note:		<Object>
	project:		<Object>
	startDate:		<Object>

endDate
	- xxxxx

hisName
	- xxxxx

history
	- xxxxx

id
	- xxxxx

note
	- xxxxx

project
	- xxxxx

startDate
	- xxxxx
!

!XpCommun methodsFor: 'private' stamp: 'rga 1/4/2015 03:53'!
asSelector
	"For example if anObject= aXpMember, the method will return:
	#members witch is aSelector "
	| mot |
	mot := self  class name.
	mot := mot copyFrom: 3 to: mot size.
	^ mot :=( mot withFirstCharacterDownshifted , 's') asSymbol! !

!XpCommun methodsFor: 'list' stamp: 'RGA 12/12/2014 12:22'!
cyclesNamesList

	(self projectExist and:[self project cycles notEmpty ])
		ifTrue: [^ self project cycles
						collect: [:cycle | cycle  hisName]]! !

!XpCommun methodsFor: 'defaults' stamp: 'RGA 10/29/2014 12:26'!
defaultEndDate
"Contrat d'un an"
	^ Date new addMonths: 12! !

!XpCommun methodsFor: 'defaults' stamp: 'RGA 11/7/2014 18:52'!
defaultName
	^ 'Sans nom'! !

!XpCommun methodsFor: 'defaults' stamp: 'rga 1/6/2011 21:38'!
defaultNote
	^ '...  '! !

!XpCommun methodsFor: 'defaults' stamp: 'RGA 10/28/2014 13:55'!
defaultStartDate

	^Date today ! !

!XpCommun methodsFor: 'private' stamp: 'RGA 11/22/2014 08:56'!
detail
	self subclassResponsibility! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 12/17/2014 14:37'!
end
	^ end! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/4/2015 18:09'!
end: aDate
	end := aDate! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/6/2011 21:39'!
hisName
	^ hisName! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 12/5/2009 10:28'!
hisName: aString
	hisName := aString! !

!XpCommun methodsFor: 'lazzy-initialisation' stamp: 'test 2/26/2009 12:52'!
history
	^ history ifNil: [ history := OrderedCollection new ]! !

!XpCommun methodsFor: 'accessing' stamp: 'test 2/26/2009 12:52'!
history: anArray 
	self history add: anArray! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 3/23/2009 17:08'!
id
	^ id! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 3/23/2009 17:08'!
id: anObject
	id := anObject! !

!XpCommun methodsFor: 'initialization' stamp: 'rga 12/17/2014 14:40'!
initialize

	self hisName: self defaultName.
	self note: self defaultNote.
	self startDate: self defaultStartDate.
	self end: self defaultEndDate.! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'rga 12/17/2014 14:35'!
magritteDescriptionEndDate
	<magritteDescription>
	^ MADateDescription  new
		selectorAccessor: #end ;
		label: 'Fin' ;
		priority: 50 ;
		default:  Date new;
		yourself! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'RGA 11/23/2014 20:00'!
magritteDescriptionHisName
	 	<magritteDescription>
	^ MAStringDescription  new
		selectorAccessor: #hisName ;
		label: 'Nom' ;
		priority: 10 ;
		beRequired  ;
		addCondition: [ :value | (value size <= 24)]
		labelled: 'Le nom est trop long' ;
		yourself
! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:00'!
magritteDescriptionNote
	<magritteDescription>	
	^ MAMemoDescription  new
		selectorAccessor: #note ;
		label: 'Note' ;
		priority: 100 ;
		default: '' ;
		yourself! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:01'!
magritteDescriptionStartDate
		<magritteDescription>
	^ MADateDescription  new
		selectorAccessor: #startDate ;
		label: 'Dbut' ;
		priority: 40 ;
		default:  Date new;
		yourself! !

!XpCommun methodsFor: 'list' stamp: 'RGA 12/12/2014 12:23'!
membersNamesList
	
	(self projectExist  and:[ self project members notEmpty ])
		 ifTrue:[ ^ self project members collect: [:membre | membre  hisName]]! !

!XpCommun methodsFor: 'list' stamp: 'rga 1/5/2015 13:09'!
namesOfThisCollection: aCollection
	^aCollection collect:[ :ea | ea hisName] 
	! !

!XpCommun methodsFor: 'magritteDescription' stamp: 'RGA 11/24/2014 20:29'!
normalDescriptionPlusID
" This is for dynamic description. i.e : when we want to add something 'on the spot' to an already defined description (Magritte only).  Here we want to add 'ID' to a description"
	^ self magritteDescription copy
		add: (MANumberDescription new
			selectorAccessor: #id ;
			label: 'ID' ;
			priority: 5 ;
			beReadonly  ;
			yourself  )! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/6/2011 21:36'!
note
	^ note ! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 12/5/2009 10:35'!
note: aString
	note := aString! !

!XpCommun methodsFor: 'accessing' stamp: 'RGA 11/26/2014 11:10'!
owner
	^ owner! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/4/2015 15:43'!
owner: aXpMember
"aXpMember"
	owner := aXpMember! !

!XpCommun methodsFor: 'accessing' stamp: 'RGA 11/26/2014 11:39'!
ownerName
	
	^ owner isNil 
		ifTrue:[ 'Non-attribu']
		ifFalse:[self owner hisName]! !

!XpCommun methodsFor: 'accessing' stamp: 'RGA 11/26/2014 12:24'!
ownerName: aName
	owner isNil 
	ifFalse:[self owner hisName: aName]! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 2/23/2009 14:22'!
project
	^ project! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 2/23/2009 14:22'!
project: anObject
	project := anObject! !

!XpCommun methodsFor: 'testing' stamp: 'RGA 11/8/2014 23:00'!
projectExist
	^ project notNil! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 1/9/2015 16:34'!
projectName 
"as some project may have the same name with a different startDate"
^ project hisName , $- , project startDate ! !

!XpCommun methodsFor: 'list' stamp: 'RGA 12/12/2014 12:09'!
releasesNamesList

	(self projectExist and:[self project releases notEmpty] ) 
		ifTrue:[^ self project releases collect: [:aRelease | aRelease   hisName ] ]! !

!XpCommun methodsFor: 'private' stamp: 'RGA 11/7/2014 23:14'!
removeSelf
	self subclassResponsibility! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 12/17/2014 14:36'!
startDate
	^ start! !

!XpCommun methodsFor: 'accessing' stamp: 'rga 12/17/2014 14:36'!
startDate: anObject
	start := anObject! !

!XpCommun methodsFor: 'list' stamp: 'RGA 12/12/2014 12:23'!
useCasesNamesList

	(self projectExist   and:[self project useCases notEmpty ])	
		ifTrue:[ ^self project useCases collect: [:case | case  hisName ]]! !

XpCommun subclass: #XpCycle
	instanceVariableNames: 'capacityPts useCases release'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpCycle commentStamp: 'RGA 11/24/2014 20:04' prior: 0!
A XpCycle is used to be part of a XpRelease and is composed of useCases .

Instance Variables
	capacityPts:		<Object>
	release:		<Object>
	useCases:		<Object>

capacityPts
	- xxxxx

release
	- xxxxx

useCases
	- xxxxx
!

!XpCycle methodsFor: 'accessing' stamp: 'rga 2/17/2009 12:07'!
capacityPts
	^ capacityPts! !

!XpCycle methodsFor: 'accessing' stamp: 'rga 12/27/2014 10:04'!
capacityPts: aString

	capacityPts := aString

! !

!XpCycle methodsFor: 'actions' stamp: 'rga 12/15/2014 22:35'!
choixRelease
"Pas encore utilis, en ai-je besoin?"

	^ Set newFrom: project releases! !

!XpCycle methodsFor: 'accessing' stamp: 'rga 1/7/2015 17:55'!
done
"for display purpose"
		self ucLoad   isZero 
			ifTrue: [^0 asString  , '%'] 
			ifFalse: 
			[^(self ucDonePts   / self ucLoad *100) truncated asString , ' % ']! !

!XpCycle methodsFor: 'initialization' stamp: 'rga 1/5/2015 22:05'!
initialize

	
	super initialize.	
	useCases := Set new.
	self capacityPts: 0.
! !

!XpCycle methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 00:30'!
magritteDescriptionCapacityPts
	<magritteDescription>	
	^ MANumberDescription  new
		selectorAccessor: #capacityPts ;
		label: 'Capacit' ;
		priority: 70 ;
		default: 0 ;
		yourself! !

!XpCycle methodsFor: 'magritteDescription' stamp: 'RGA 11/19/2014 18:45'!
magritteDescriptionDone
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #done ;
		label: '% Ralis' ;
		priority: 80 ;
		beReadonly ;
		yourself
! !

!XpCycle methodsFor: 'magritteDescription' stamp: 'rga 12/22/2014 12:14'!
magritteDescriptionLoad
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #ucLoad ;
		label: 'Charge' ;
		priority: 75 ;
		beReadonly ;
		yourself
! !

!XpCycle methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 00:45'!
magritteDescriptionRelease
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #releaseName;
		label: 'Livrable' ;
		priority: 20 ;
		options: self releasesNamesList;
		default: '' ;
		yourself
		
	
! !

!XpCycle methodsFor: 'maui' stamp: 'rga 1/7/2015 17:42'!
mauiDefaultColumns
	^ #(#hisName #releaseName #startDate #end #capacityPts #ucLoad  #done )! !

!XpCycle methodsFor: 'actions' stamp: 'rga 1/7/2015 18:02'!
newHistory

	^Array 
		with: Date today
		with: self startDate
		with: self capacityPts
		with: self ucLoad
		with: self done
		with: self ucPtsLeft 	! !

!XpCycle methodsFor: 'associations' stamp: 'rga 1/6/2011 22:16'!
release
	
		^release
		 ! !

!XpCycle methodsFor: 'associations' stamp: 'rga 12/28/2014 18:03'!
release: aRelease
"This is a setter for release in XpCycle . But it also takes care  of the fact that and old release could be set yet.
So first remove the cycle associated with this old release if any, second set the new release, third associate this cycle to the new release."
	release isEmptyOrNil 
	ifFalse:[self release removeCycle: self].
	release := aRelease.
	self release cycles: self .
! !

!XpCycle methodsFor: 'accessing' stamp: 'rga 1/6/2011 22:35'!
releaseName
	
		^ self release ifNotNil:[ self release hisName]
		 ! !

!XpCycle methodsFor: 'accessing' stamp: 'rga 12/15/2014 22:28'!
releaseName: aName
"magritte command a setter an a getter even if we use only the getter"! !

!XpCycle methodsFor: 'removing' stamp: 'RGA 11/27/2014 18:22'!
removeSelf
	| lesCycles |
	lesCycles := project cycles.
	(lesCycles includes: self)
		ifTrue: [lesCycles remove: self ]! !

!XpCycle methodsFor: 'calcul' stamp: 'rga 1/7/2015 21:25'!
ucDonePts
"useCases donePts associated with that cycle"
	self useCases ifEmpty:[^0 ].
	^self useCases inject: 0 into:[ :tot :ea | tot + ea tskDonePts].

! !

!XpCycle methodsFor: 'calcul' stamp: 'rga 1/5/2015 12:13'!
ucLoad
"useCases estimatedPts associated with that cycle"
	| total 	|
	self useCases isEmptyOrNil  ifTrue:[^0].
	total := self useCases inject: 0 into:[ :tot :ea | tot + ea estimatedPts].
	^total! !

!XpCycle methodsFor: 'calcul' stamp: 'rga 1/7/2015 18:00'!
ucPtsLeft
	^ self ucLoad - self ucDonePts ! !

!XpCycle methodsFor: 'associations' stamp: 'rga 2/17/2009 12:07'!
useCases
	^ useCases! !

!XpCycle methodsFor: 'associations' stamp: 'rga 1/6/2011 22:31'!
useCases: aUCase
	^ self useCases add: aUCase.! !

XpCommun subclass: #XpMember
	instanceVariableNames: 'role tasks useCases email password descriptions'
	classVariableNames: 'Bidon'
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpMember commentStamp: 'RGA 10/29/2014 12:01' prior: 0!
A XpMember is : people member of a project. Member may be assignedTo: (0/n) tasks or\and (0/n) tests

Instance Variables
	email:		<aString>
	password:		<aString>
	role:		<aString>
	tasks:		<an orderedCollection of XpTasks, empty at first>
	useCases:		<an orderedCollection of  XpUseCases empty at first>

email
	- xxxxx

password
	- xxxxx

role
	- These are predefined roles. Look class side 'descriptionRole'

tasks
	- xxxxx

useCases
	- xxxxx
class variable:

Bidon 
	- anXpMember bidon to be use when there is no owner yet assign
	!

!XpMember methodsFor: 'defaults' stamp: 'rga 12/20/2014 15:37'!
defaultRole
	^ 'Programmeur'! !

!XpMember methodsFor: 'calcul' stamp: 'rga 1/7/2015 20:51'!
done
"percentage of tskEstimate done"
		self tskEstimate  isZero 
			ifTrue: [^0 asString  , '%'] 
			ifFalse: 
			[^(self donePts  / self tskEstimate *100) truncated asString , ' % ']! !

!XpMember methodsFor: 'calcul' stamp: 'rga 1/7/2015 20:51'!
donePts
"about tasks"
	| total allTasks |
	self project ifNil:[^0].
	allTasks := self  tasks.
	allTasks  ifEmpty:[^0 ].
	^total := allTasks 
		inject: 0
		into: [ :tot :ea | tot + ea donePts ].

! !

!XpMember methodsFor: 'accessing' stamp: 'rga 3/19/2009 11:10'!
email
	^ email! !

!XpMember methodsFor: 'accessing' stamp: 'rga 2/11/2010 14:03'!
email: aString
	email := aString! !

!XpMember methodsFor: 'accessing' stamp: 'test 2/26/2009 12:57'!
history

	^ nil! !

!XpMember methodsFor: 'accessing' stamp: 'RGA 10/23/2014 08:55'!
history: anArray
"We don''t need it for member'"
	self shouldNotImplement
	
! !

!XpMember methodsFor: 'initialization' stamp: 'rga 1/6/2011 22:03'!
initTasks
	tasks := OrderedCollection new! !

!XpMember methodsFor: 'initialization' stamp: 'rga 1/6/2011 22:06'!
initUseCases
	useCases := OrderedCollection new! !

!XpMember methodsFor: 'initialization' stamp: 'RGA 10/29/2014 11:59'!
initialize

	super initialize.	
	self initTasks.
	self initUseCases.
	self role: self defaultRole.
	self email: ''	.
	self password: ''	
	
	
	! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:02'!
magritteDescriptionDone
	<magritteDescription>
	^ MANumberDescription  new
		accessor: #done ;
		label: 'Ralis' ;
		priority: 25 ;
		beReadonly;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:02'!
magritteDescriptionEmail
	<magritteDescription>	
	^ MAStringDescription  new
		accessor: #email ;
		label: 'Courriel' ;
		priority: 11 ;
		beOptional ;
		addCondition: [ :value | (value ~= ' ') 
									and: [value size <= 20]]
		labelled: 'Courriel invalide ou > 20' ;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'rga 12/22/2014 12:30'!
magritteDescriptionLoad
	<magritteDescription>	
	^ MANumberDescription  new
		accessor: #tskEstimate ;
		label: 'Points de charge' ;
		priority: 20 ;
		beReadonly;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 11/20/2014 07:44'!
magritteDescriptionNbTasks
	<magritteDescription>	
	^ MANumberDescription  new
		accessor: #nbTasks ;
		label: 'Nb Tches' ;
		priority: 18 ;
		beReadonly;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'RGA 10/23/2014 15:10'!
magritteDescriptionPassword
	<magritteDescription>		
	^ MAStringDescription  new
		accessor: #password ;
		label: 'Mot de passe ' ;
		priority: 12 ;
		beOptional ;
		addCondition: [ :value | (value ~= ' ') 
									and: [value size <= 20]]
		labelled: 'Mot de passe invalide ou > 20' ;
		yourself
! !

!XpMember methodsFor: 'magritteDescription' stamp: 'rga 12/28/2014 09:54'!
magritteDescriptionRole
	<magritteDescription>
	^ MASingleOptionDescription  new
		accessor: #role ;
		label: 'Rle' ;
		priority: 14 ;
		options: #(Programmeur AnalysteProgrammeur Gestionnaire Coach Analyste Testeur);
		beRequired ;
		beSorted ;
		default: self defaultRole ;
		yourself
! !

!XpMember methodsFor: 'maui' stamp: 'rga 12/22/2014 12:31'!
mauiDefaultColumns

^#(#hisName #role #nbTasks #tskEstimate #done)! !

!XpMember methodsFor: 'calcul' stamp: 'RGA 12/12/2014 11:26'!
nbTasks

	^ self projectExist 
	ifTrue:[self tasks size]! !

!XpMember methodsFor: 'accessing' stamp: 'RGA 10/29/2014 11:42'!
owner
	self shouldNotImplement! !

!XpMember methodsFor: 'accessing' stamp: 'RGA 10/29/2014 11:42'!
owner: aMember
	self shouldNotImplement! !

!XpMember methodsFor: 'accessing' stamp: 'rga 3/19/2009 11:12'!
password
	^ password! !

!XpMember methodsFor: 'accessing' stamp: 'rga 2/11/2010 14:04'!
password: aString
	password := aString! !

!XpMember methodsFor: 'calcul' stamp: 'rga 1/7/2015 20:52'!
ptsLeft
"about tasks"
	| aLoad aScore |
	aScore := self donePts.
	aLoad := self tskEstimate.
	(aLoad >= 0 and: [ aScore >= 0 ]) ifFalse: [ ^ 0 ].
	^ aLoad - aScore! !

!XpMember methodsFor: 'private' stamp: 'rga 1/5/2015 21:39'!
removeSelf
"delete from de project"	
	| lesMembres |
	lesMembres := project members . 
	(lesMembres includes: self)
		ifTrue: [lesMembres remove: self ]! !

!XpMember methodsFor: 'accessing' stamp: 'rga 2/12/2009 21:01'!
role
	^ role! !

!XpMember methodsFor: 'accessing' stamp: 'rga 2/11/2010 14:02'!
role: aString
	role := aString! !

!XpMember methodsFor: 'associations' stamp: 'rga 12/18/2014 17:10'!
tasks
"Tasks associated with aMember"
	^ self projectExist 
	ifTrue:[project tasks select: [:task | task owner  = self ]]! !

!XpMember methodsFor: 'associations' stamp: 'rga 12/18/2014 17:11'!
tasks: aTask
"associated with aMember"
	 self tasks add: aTask! !

!XpMember methodsFor: 'calcul' stamp: 'rga 1/7/2015 20:53'!
tskEstimate
 " the load is the addition of all  tasks' estimate' "
	| total  allTasks	|
	project ifNil:[ ^ 0].
	allTasks := self  tasks.
	allTasks  ifEmpty: [^0].
	total  := allTasks  inject: 0 into:[ :tot :ea | tot + ea estimatedPts ].
	^total! !

!XpMember methodsFor: 'associations' stamp: 'rga 12/18/2014 17:11'!
useCases
"associated with aMember"	
	^ useCases ! !

!XpMember methodsFor: 'associations' stamp: 'rga 12/18/2014 17:11'!
useCases:  aUseCase
"associated with aMember"
	self useCases add: aUseCase! !

XpCommun subclass: #XpProject
	instanceVariableNames: 'useCases tasks tests releases oldMembers members aCase cycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpProject commentStamp: 'RGA 11/24/2014 20:04' prior: 0!
A XpProject is composed of differents releases and members.

Instance Variables
	cycles:		<Object>
	members:		<Object>
	oldMembers:		<Object>
	releases:		<Object>
	tasks:		<Object>
	tests:		<Object>
	useCases:		<Object>

iterations
	- xxxxx

members
	- xxxxx

oldMembers
	- xxxxx

releases
	- xxxxx

tasks
	- xxxxx

tests
	- xxxxx

useCases
	- xxxxx
!

!XpProject methodsFor: 'private' stamp: 'rga 12/21/2014 21:53'!
addACycle: aCycle
"PRIVATE - Development only: use with caution"	
	aCycle project: self.
	self cycles add: aCycle! !

!XpProject methodsFor: 'private' stamp: 'rga 12/21/2014 21:53'!
addAMember: aMember 
"PRIVATE - Development only: use with caution"	
	aMember project: self.
	self members add: aMember! !

!XpProject methodsFor: 'private' stamp: 'rga 12/21/2014 21:53'!
addARelease: aRelease 
"PRIVATE - Development only: use with caution"	
	aRelease project: self.
 	self releases add: aRelease! !

!XpProject methodsFor: 'private' stamp: 'rga 12/21/2014 21:53'!
addATask: aTask 
"PRIVATE - Development only: use with caution"	
	aTask project: self.
	self tasks add: aTask! !

!XpProject methodsFor: 'private' stamp: 'rga 12/21/2014 21:53'!
addATest: aTest 
"PRIVATE - Development only: use with caution"	
	aTest project: self.
	self tests add: aTest! !

!XpProject methodsFor: 'private' stamp: 'rga 12/21/2014 21:54'!
addAUseCase: aCase 
"PRIVATE - Development only: use with caution"	
	aCase project: self.
	self useCases add: aCase! !

!XpProject methodsFor: 'creating' stamp: 'rga 1/6/2015 18:33'!
createNewCycle 
"Maui version. "	
	| anObject |
	anObject :=  XpCycle  new.
	self addACycle:  anObject.
	anObject maui openNewViewNamed: 'CycleEditorViewer'.
! !

!XpProject methodsFor: 'creating' stamp: 'rga 1/6/2015 18:26'!
createNewMember
	"Maui version. Create and set the member's project"
	| aMember |
	aMember :=  XpMember new.
	self  addAMember: aMember.
	aMember maui openNewViewNamed: 'MemberEditorViewer'.! !

!XpProject methodsFor: 'creating' stamp: 'rga 1/6/2015 18:31'!
createNewRelease
"Maui version. 	"
	| anObject |
	anObject :=  XpRelease new.
	self  addARelease: anObject.
	anObject maui openNewViewNamed: 'ReleaseEditorViewer'.! !

!XpProject methodsFor: 'creating' stamp: 'rga 1/6/2015 18:33'!
createNewTask 
	"Maui version. 	"
	| anObject |
	anObject :=  XpTask new.
	self addATask: anObject.
	anObject maui openNewViewNamed: 'TaskEditorViewer'.
! !

!XpProject methodsFor: 'creating' stamp: 'rga 1/6/2015 18:33'!
createNewTest   
	"Maui version. 	"
	| anObject |
	anObject :=  XpTest  new.
	self addATest: anObject.
	anObject maui openNewViewNamed: 'TestEditorViewer'.
! !

!XpProject methodsFor: 'creating' stamp: 'rga 1/6/2015 18:33'!
createNewUseCase  
	"Maui version. 	"	
	| anObject |
	anObject :=  XpUseCase  new.
	self addAUseCase: anObject.
	anObject maui openNewViewNamed: 'UseCaseEditorViewer'.! !

!XpProject methodsFor: 'accessing' stamp: 'RGA 11/24/2014 19:36'!
cycles
	^ cycles! !

!XpProject methodsFor: 'finding' stamp: 'rga 1/4/2015 03:54'!
find: anObject byName: aName 
	    
	| aSelector objectsOfThisTypeInProject |
	aSelector := anObject asSelector.
	objectsOfThisTypeInProject:=self perform: aSelector.
	^ objectsOfThisTypeInProject detect: [ :ea | ea hisName = aName ]
		ifNone: [ nil ]! !

!XpProject methodsFor: 'finding' stamp: 'rga 1/10/2011 14:29'!
findTask: aTask
	

	^ self tasks detect: [ :ea | ea == aTask] ifNone:[].
! !

!XpProject methodsFor: 'finding' stamp: 'rga 1/7/2011 15:35'!
findUseCase: aCase
	

	^  self useCases detect: [ :ea | ea = aCase] ifNone:[nil]! !

!XpProject methodsFor: 'accessing' stamp: 'test 2/26/2009 12:56'!
history
"We don''t need it for project'"
	^ nil! !

!XpProject methodsFor: 'accessing' stamp: 'test 2/26/2009 12:56'!
history: anArray
"We don''t need it for project'"
	^ nil! !

!XpProject methodsFor: 'initialization' stamp: 'rga 1/5/2015 12:54'!
initialize
	super initialize.
	self initializeCollections.
! !

!XpProject methodsFor: 'initialization' stamp: 'RGA 11/24/2014 19:36'!
initializeCollections
	useCases := OrderedCollection new.
	members := OrderedCollection new.
	oldMembers := OrderedCollection new.
	tasks := OrderedCollection new.
	tests := OrderedCollection new.
	releases := OrderedCollection new.
	cycles := OrderedCollection new.
! !

!XpProject methodsFor: 'accessing' stamp: 'rga 1/3/2010 04:13'!
members
	^ members! !

!XpProject methodsFor: 'usedByUnitTests' stamp: 'rga 12/19/2014 18:44'!
newCycle
	| anIteration |
	anIteration := XpCycle new.
	anIteration history: anIteration newHistory.
	self addACycle: anIteration.
	^ anIteration! !

!XpProject methodsFor: 'usedByUnitTests' stamp: 'rga 12/19/2014 18:45'!
newMember
"used exclusively for tests or dataTest."
	| aMember |
	aMember := XpMember new.
	self addAMember: aMember.
	^ aMember! !

!XpProject methodsFor: 'usedByUnitTests' stamp: 'rga 12/19/2014 18:45'!
newRelease
	| aRel |
	aRel := XpRelease new.
	aRel history: aRel newHistory.
	self addARelease: aRel.
	^ aRel! !

!XpProject methodsFor: 'usedByUnitTests' stamp: 'rga 12/19/2014 18:46'!
newTask
	| aTask |
	aTask := XpTask new.
	aTask history: aTask newHistory.
	self addATask: aTask.
	^ aTask! !

!XpProject methodsFor: 'usedByUnitTests' stamp: 'rga 12/19/2014 18:46'!
newTest
	| aTest |
	aTest := XpTest new.
	aTest history: aTest newHistory.
	self addATest: aTest.
	^ aTest! !

!XpProject methodsFor: 'usedByUnitTests' stamp: 'rga 12/19/2014 18:47'!
newUseCase
	| aCase |
	aCase := XpUseCase new.
	aCase history: aCase newHistory.
	self addAUseCase: aCase.
	^ aCase! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/25/2009 10:41'!
oldMembers
	^ oldMembers! !

!XpProject methodsFor: 'accessing' stamp: 'rga 1/7/2011 15:17'!
oldMembers: anObject
	self oldMembers add: anObject! !

!XpProject methodsFor: 'accessing' stamp: 'rga 12/29/2014 16:30'!
programers
	^ members reject:[:ea | ea role = 'Coach' or:[ea role ='Testeur']]! !

!XpProject methodsFor: 'accessing' stamp: 'rga 1/5/2015 12:55'!
project

	self shouldNotImplement ! !

!XpProject methodsFor: 'accessing' stamp: 'rga 1/5/2015 12:55'!
project: aProject

	self shouldNotImplement ! !

!XpProject methodsFor: 'accessing' stamp: 'rga 1/7/2015 21:48'!
projectName 
"as some project may have the same name with a different startDate"
^ self hisName , $- , self startDate ! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/17/2009 11:11'!
releases
	^ releases! !

!XpProject methodsFor: 'removing' stamp: 'rga 12/17/2014 14:40'!
removeMember: aMember 
	"Here the endDate is a noMoreActiveDate"
	aMember end: Date today.
	self oldMembers add: aMember.
	self members 
		remove: aMember
		ifAbsent: [  ]! !

!XpProject methodsFor: 'removing' stamp: 'rga 12/9/2009 10:38'!
removeSelf
	self shouldNotImplement! !

!XpProject methodsFor: 'removing' stamp: 'rga 1/7/2011 15:37'!
removeTest: aTest

	self tests remove: aTest ! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/12/2009 17:00'!
tasks
	^ tasks! !

!XpProject methodsFor: 'accessing' stamp: 'rga 2/12/2009 17:00'!
tests
	^ tests! !

!XpProject methodsFor: 'accessing' stamp: 'RGA 11/6/2014 21:10'!
useCases
	^ useCases! !

XpCommun subclass: #XpRelease
	instanceVariableNames: 'capacityPts cycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpRelease commentStamp: 'RGA 11/24/2014 20:05' prior: 0!
A XpRelease is composed of differents cycles.

Instance Variables
	capacityPts:		<Object>
	cycles:		<Object>

capacityPts
	- xxxxx

cycles
	- xxxxx
!

!XpRelease methodsFor: 'accessing' stamp: 'rga 1/7/2015 21:52'!
capacityPts: aNumber
"of this Release"
	capacityPts := aNumber! !

!XpRelease methodsFor: 'associations' stamp: 'rga 12/21/2014 20:59'!
cycles
"associated with aRelease"	
	^ cycles ! !

!XpRelease methodsFor: 'associations' stamp: 'rga 12/26/2014 18:47'!
cycles: aCycle
"add aCyce to aRelease.Use exclusively by #release: in XpCycle"
	 cycles add: aCycle.
! !

!XpRelease methodsFor: 'calcul' stamp: 'rga 1/7/2015 17:46'!
cyclesCapacityPts
"from all cycles of a release"
	^ ( cycles isEmptyOrNil)
		ifFalse:[
			( cycles collect:[:ea| ea capacityPts]) 
				inject: 0 into: [:sum :next | sum + next  ]]
		ifTrue:[0]! !

!XpRelease methodsFor: 'calcul' stamp: 'rga 1/7/2015 18:13'!
cyclesUcLoad
"These are cycles ucLoad for this release"
	 cycles ifEmpty:[^0].
	^ cycles inject: 0 into:[ :tot :ea | tot + ea ucLoad ].
! !

!XpRelease methodsFor: 'calcul' stamp: 'rga 1/7/2015 21:06'!
done
"percentage of donePts versus loadPts of cyclesUseCase"
		self cyclesUcLoad  isZero 
			ifTrue: [^0 asString  , '%'] 
			ifFalse: [^(self donePts  / self cyclesUcLoad *100) truncated asString , ' % ']! !

!XpRelease methodsFor: 'calcul' stamp: 'rga 1/7/2015 21:02'!
donePts
"about Cycles contain in that Release"
	| total |
	self cycles
		ifEmpty: [^ 0].
	total := self cycles
				inject: 0
				into: [:tot :ea | tot + ea ucDonePts].
	^ total! !

!XpRelease methodsFor: 'initialization' stamp: 'RGA 11/24/2014 19:47'!
initCycles

	 cycles := OrderedCollection new.
! !

!XpRelease methodsFor: 'initialization' stamp: 'rga 12/29/2014 17:42'!
initialize

	super initialize.
	self capacityPts: 6.
	self initCycles
! !

!XpRelease methodsFor: 'calcul' stamp: 'rga 1/7/2015 18:16'!
loadPercent
	"cycles capacityPts / ucLoad - for display purpose"
	| load |
	load := self cyclesUcLoad.
	^ (load isZero or:[capacityPts isNil ])
		ifTrue: [0 asString , '%']
		ifFalse: [
			(load / capacityPts  * 100) truncated asString , '%']! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'rga 1/7/2015 17:47'!
magritteDescriptionCapacity
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #cyclesCapacityPts ;
		label: 'Capacit' ;
		priority: 60 ;
		default: 0;
		yourself
! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'RGA 11/19/2014 18:37'!
magritteDescriptionDone
	<magritteDescription>	
	^ MANumberDescription  new
		selectorAccessor: #done ;
		label: 'Ralis' ;
		priority: 75 ;
		beReadonly;
		yourself
! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:03'!
magritteDescriptionLeft
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #ptsLeft ;
		label: 'Pts restants' ;
		priority: 80 ;
		beReadonly;
		yourself
! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'rga 1/7/2015 18:16'!
magritteDescriptionLoad
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #cyclesUcLoad ;
		label: 'Charge' ;
		priority: 70 ;
		beReadonly;
		yourself
! !

!XpRelease methodsFor: 'magritteDescription' stamp: 'rga 12/27/2014 09:51'!
magritteDescriptionLoadPercent
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #loadPercent ;
		label: '% de Charge' ;
		priority: 73 ;
		beReadonly;
		yourself
! !

!XpRelease methodsFor: 'maui' stamp: 'rga 1/7/2015 18:16'!
mauiDefaultColumns

^#(#hisName #startDate #end #cyclesCapacityPts #cyclesUcLoad #loadPercent #done #ptsLeft  )! !

!XpRelease methodsFor: 'creation' stamp: 'rga 1/7/2015 18:16'!
newHistory

	^Array 
		with: Date today
		with: self startDate
		with: self cyclesCapacityPts
		with: self cyclesUcLoad
		with: self done
		with: self ptsLeft	! !

!XpRelease methodsFor: 'calcul' stamp: 'rga 1/7/2015 18:16'!
ptsLeft
"ptsLeft for cycles ucLoad"
	| load |
	load := self cyclesUcLoad.
	^ (load isZero) 
			ifTrue: [ 0 ]
			ifFalse: [ (load - self donePts)  ]! !

!XpRelease methodsFor: 'associations' stamp: 'rga 12/26/2014 18:47'!
removeCycle: aCycle 
"From the current Release"	
	^ cycles isEmptyOrNil
		ifFalse: [ cycles
				remove: aCycle
				ifAbsent: []]! !

!XpRelease methodsFor: 'private' stamp: 'rga 1/4/2015 18:47'!
removeSelf
"Remove the Release BUGGY- seems to remove the last in the collection.buzz"
	| theReleases |
	theReleases := project releases . 
	(theReleases notNil or:[theReleases notEmpty ])
	ifTrue:[
			(theReleases includes: self)
				ifTrue: [theReleases remove: self ]]! !

XpCommun subclass: #XpTask
	instanceVariableNames: 'estimatedPts donePts status useCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpTask methodsFor: 'associations' stamp: 'rga 1/5/2015 17:55'!
associateToUseCaseNamed: aName
"if aUseCase named: aName exist, set it as the associate UseCase to the present task"
	| aCase|
	self projectExist ifTrue:[
	aCase := self project useCases  anyOne .
	aCase := self project find: aCase byName: aName].
	aCase ifNotNil:
		[  aCase tasks: self.
		  self useCase: aCase.]
	! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/17/2009 15:55'!
donePts
	^ donePts! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/17/2009 15:55'!
donePts: anInteger 
	donePts := anInteger! !

!XpTask methodsFor: 'accessing' stamp: 'rga 12/17/2014 14:40'!
end: aDateObject
	end := aDateObject.
	self status: 'Done'! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/13/2009 09:48'!
estimatedPts
	^ estimatedPts! !

!XpTask methodsFor: 'accessing' stamp: 'rga 2/13/2009 09:48'!
estimatedPts: anInteger 
	estimatedPts := anInteger! !

!XpTask methodsFor: 'initialization' stamp: 'RGA 10/29/2014 12:33'!
initialize

	super initialize.
	self estimatedPts: 0.
	self donePts: 0.
	self status: 'To-Do'.
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'rga 1/7/2015 18:19'!
magritteDescriptionDonePts
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #tskDonePts ;
		label: 'Pts raliss' ;
		priority: 80 ;
		default: 0 ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionEstimatedPts
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #estimatedPts ;
		label: 'Pts estims' ;
		priority: 70 ;
		default: 0 ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionLeft
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #ptsLeft ;
		label: 'Pts restants' ;
		priority: 90 ;
		beReadonly ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 11/7/2014 19:17'!
magritteDescriptionOwnerName
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #ownerName ;
		label: 'Nom du responsable' ; 
		priority: 40 ;
		options: self membersNamesList;
		beSorted;
		default: '--' ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionStatus
	<magritteDescription>
	^ MAStringDescription  new
		selectorAccessor: #status ;
		label: 'Statut' ;
		priority: 30 ;
		default: '' ;
		yourself
! !

!XpTask methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 23:27'!
magritteDescriptionUseCase
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #useCaseName ;
		label: 'Cas d''utilisation' ; 
		priority: 20 ;
		options: self useCasesNamesList;
		beSorted;
		default: 'Non-attribu' ;
		yourself! !

!XpTask methodsFor: 'maui' stamp: 'rga 1/7/2015 18:20'!
mauiDefaultColumns

^#(#hisName #useCaseName #status #ownerName  #estimatedPts  #tskDonePts  #ptsLeft  )! !

!XpTask methodsFor: 'actions' stamp: 'rga 1/7/2011 22:49'!
newHistory

	^Array 
		with: Date today
		with: self startDate
		with: self estimatedPts
		with: self donePts! !

!XpTask methodsFor: 'calcul' stamp: 'rga 12/29/2014 16:37'!
ptsLeft
	^ (self estimatedPts isZero) 
			ifTrue: [ 0 ]
			ifFalse: [ (self estimatedPts - donePts)  ]
! !

!XpTask methodsFor: 'accessing' stamp: 'RGA 11/19/2014 09:15'!
ptsLeft: an
"MagritteDescription exige a writeSelector meme si on ne l'utilise pas"! !

!XpTask methodsFor: 'private' stamp: 'RGA 11/27/2014 18:30'!
removeSelf
	| lesTaches |
	lesTaches := project tasks  . 
	(lesTaches includes: self)
		ifTrue: [lesTaches remove: self ]! !

!XpTask methodsFor: 'accessing' stamp: 'rga 12/17/2014 14:36'!
startDate: aDateObject
	start := aDateObject.
	self status: 'In-Progress'! !

!XpTask methodsFor: 'accessing' stamp: 'RGA 11/1/2014 21:51'!
status
"Le status est gnr par date de dbut, de fin, etc....chercher les 'Senders'"
	^ status! !

!XpTask methodsFor: 'accessing' stamp: 'RGA 11/1/2014 21:51'!
status: anObject
"Le status est gnr par date de dbut, de fin, etc....chercher les 'Senders'"
	status := anObject! !

!XpTask methodsFor: 'associations' stamp: 'rga 2/24/2009 17:33'!
useCase
	^ useCase! !

!XpTask methodsFor: 'associations' stamp: 'rga 2/24/2009 17:33'!
useCase: anObject
	useCase := anObject! !

!XpTask methodsFor: 'associations' stamp: 'RGA 11/19/2014 17:32'!
useCaseName 
	^ useCase isNil 
		ifTrue:[ 'aucun'] 
		ifFalse:[useCase hisName ]! !

XpCommun subclass: #XpTest
	instanceVariableNames: 'status useCase'
	classVariableNames: 'Status'
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpTest methodsFor: 'queries' stamp: 'rga 2/17/2009 14:46'!
allStatus

	^ #('Not-Passed' 'Passed')! !

!XpTest methodsFor: 'associations' stamp: 'rga 1/5/2015 17:55'!
associateToUseCaseNamed: aName
"if aUseCase named: aName exist, set it as the associate UseCase to the present XpTest "
	| aUseCase |
	self projectExist ifTrue:[
	aUseCase := self project useCases  anyOne .
	aUseCase :=( self project find: aUseCase byName: aName)].
	aUseCase ifNotNil:
		[  aUseCase tests: self.
		  self useCase: aUseCase.]
	! !

!XpTest methodsFor: 'initialization' stamp: 'rga 1/7/2011 17:13'!
initialize

	super initialize.
	self status: 'Not-Passed'.
! !

!XpTest methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionStatus
	<magritteDescription>
	^ MAStringDescription  new
		selectorAccessor: #status ;
		label: 'Statut' ;
		priority: 90 ;
		default: ' venir' ;
		yourself
! !

!XpTest methodsFor: 'magritteDescription' stamp: 'RGA 11/8/2014 23:58'!
magritteDescriptionUseCase
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #useCaseName ;
		label: 'Cas d''utilisation' ; 
		priority: 20 ;
		options: self useCasesNamesList;
		beSorted;
		default: 'Non-attribu' ;
		yourself! !

!XpTest methodsFor: 'maui' stamp: 'rga 12/27/2014 11:03'!
mauiDefaultColumns

^#(#hisName #useCaseName #status #ownerName  )! !

!XpTest methodsFor: 'queries' stamp: 'rga 1/7/2011 17:15'!
newHistory

	^Array 
		with: Date today
		with: self startDate
		with: self status
! !

!XpTest methodsFor: 'private' stamp: 'RGA 11/27/2014 18:30'!
removeSelf
	| lesTests |
	lesTests := project tests  . 
	(lesTests includes: self)
		ifTrue: [lesTests remove: self ]! !

!XpTest methodsFor: 'accessing' stamp: 'rga 2/17/2009 14:27'!
status
	^ status! !

!XpTest methodsFor: 'accessing' stamp: 'rga 2/17/2009 14:27'!
status: aString
	 status := aString! !

!XpTest methodsFor: 'associations' stamp: 'rga 2/24/2009 18:06'!
useCase
	^ useCase! !

!XpTest methodsFor: 'associations' stamp: 'RGA 11/9/2014 00:14'!
useCase: anObject
		useCase := anObject! !

!XpTest methodsFor: 'associations' stamp: 'RGA 11/9/2014 21:05'!
useCaseName
 	^ self useCase ifNotNil:[ self useCase hisName]! !

XpCommun subclass: #XpUseCase
	instanceVariableNames: 'cycle risk priority estimatedPts status tasks tests'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Model'!

!XpUseCase commentStamp: 'RGA 11/24/2014 20:06' prior: 0!
A XpUseCase is broken down in (0/n) tasks and (0/n) tests .

Instance Variables
	estimatedPts:		<Object>
	cycle:		<Object>
	owner:		<Object>
	priority:		<Object>
	risk:		<Object>
	status:		<Object>
	tasks:		<Object>
	tests:		<Object>

estimatedPts
	- xxxxx

cycle 
	- xxxxx

priority
	- xxxxx

risk
	- xxxxx

status
	- xxxxx

tasks
	- xxxxx

tests
	- xxxxx
!

!XpUseCase methodsFor: 'associations' stamp: 'rga 1/5/2015 17:52'!
associateToCycleNamed: aCycleName
"Find the project cycle with this name and associate it to this UseCase"
	|  aCycle |
	aCycle :=self project find: XpCycle new byName: aCycleName.
	aCycle notNil
		ifTrue: [aCycle useCases: self.
			cycle := aCycle.
		]
! !

!XpUseCase methodsFor: 'associations' stamp: 'RGA 11/24/2014 19:56'!
cycle
	^ cycle ! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 12/27/2014 10:39'!
cycleName
	^ cycle isNil 
		ifFalse: [cycle hisName]
		
! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
estimatedPts
	^ estimatedPts! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 1/7/2015 18:22'!
estimatedPts: aNumber
	estimatedPts := aNumber! !

!XpUseCase methodsFor: 'initialization' stamp: 'RGA 11/7/2014 19:10'!
initialize

	super initialize.
	self status: ' faire'.
	self initializeCollections.
! !

!XpUseCase methodsFor: 'initialization' stamp: 'RGA 11/7/2014 19:11'!
initializeCollections
		tasks := OrderedCollection new.
		tests := OrderedCollection new.! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 11/27/2014 19:07'!
magritteDescriptionCycleName
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #cycleName ;
		label: 'Cycle de dveloppement' ; 
		priority: 20 ;
		options: self cyclesNamesList;
		beSorted;
		default: '' ;
		yourself
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'rga 1/7/2015 18:20'!
magritteDescriptionDone
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #tskDonePts ;
		label: 'Pts raliss' ;
		priority: 65 ;
		default: 0 ;
		beReadonly;
		yourself
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionEstimatedPts
	<magritteDescription>
	^ MANumberDescription  new
		selectorAccessor: #estimatedPts ;
		label: 'Pts estims' ;
		priority: 60 ;
		default: 0 ;
		yourself
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 11/7/2014 19:17'!
magritteDescriptionOwnerName
	<magritteDescription>
	^ MASingleOptionDescription  new
		selectorAccessor: #ownerName ;
		label: 'Nom du responsable' ; 
		priority: 26 ;
		options: self membersNamesList;
		beSorted;
		default: 'Non-attribu' ;
		yourself
! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 11/7/2014 23:32'!
magritteDescriptionPriority
	<magritteDescription>
	^ MASingleOptionDescription   new
		selectorAccessor: #priority ;
		label: 'Priorit' ;
		options: #( 'Essentiel' 'Requis' 'Souhait') ;
		priority: 24 ;
		beRequired ;
		beSorted;
		default: 'Souhait' ;
		yourself! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 11/7/2014 23:39'!
magritteDescriptionRisk
	<magritteDescription>
	^ MASingleOptionDescription   new
		selectorAccessor: #risk  ;
		label: 'Risque ' ;
		options: #( 'lev' 'Moyen' 'Bas') ;
		priority: 20 ;
		beRequired ;
		beSorted;
		default: 'Bas' ;
		yourself! !

!XpUseCase methodsFor: 'magritteDescription' stamp: 'RGA 10/22/2014 11:04'!
magritteDescriptionStatus
	<magritteDescription>	
	^ MASingleOptionDescription  new
		selectorAccessor: #status ;
		label: 'Statut' ; 
		options: #( ' faire' 'En cours' 'Termin') ;
		priority: 22 ;
		beRequired ;
		beSorted;
		default: ' faire' ;
		yourself
! !

!XpUseCase methodsFor: 'maui' stamp: 'rga 1/7/2015 18:20'!
mauiDefaultColumns

^#(#hisName #cycleName #risk  #status #priority #ownerName  #estimatedPts #tskDonePts )! !

!XpUseCase methodsFor: 'actions' stamp: 'rga 1/7/2015 18:21'!
newHistory

	^Array 
		with: Date today
		with: start
		with: estimatedPts
		with: self tskEstimate
		with: self tskDonePts
! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
priority
	^ priority! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
priority: anObject
	priority := anObject! !

!XpUseCase methodsFor: 'private' stamp: 'RGA 11/27/2014 18:30'!
removeSelf
	| lesUseCases |
	lesUseCases := project useCases  . 
	(lesUseCases includes: self)
		ifTrue: [lesUseCases remove: self ]! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
risk
	^ risk! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
risk: anObject
	risk := anObject! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
status
	^ status! !

!XpUseCase methodsFor: 'accessing' stamp: 'rga 4/19/2009 11:50'!
status: anObject
	status := anObject! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 4/19/2009 11:50'!
tasks
	^ tasks! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 1/5/2015 21:53'!
tasks: aTask
"Tasks of this UseCase"	
	tasks  add: aTask! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 4/19/2009 11:50'!
tests
	^ tests! !

!XpUseCase methodsFor: 'associations' stamp: 'rga 1/5/2015 21:53'!
tests: aTest
"Tests of this UseCase"	
	tests add: aTest! !

!XpUseCase methodsFor: 'calcul' stamp: 'rga 1/7/2015 18:19'!
tskDonePts
"donePts of Tasks associated with that UseCase"
	| total 	|
	tasks ifEmpty:[^0].
	total := tasks inject: 0 into:[ :tot :ea | tot + ea donePts].
	^total			
! !

!XpUseCase methodsFor: 'calcul' stamp: 'rga 12/22/2014 12:34'!
tskEstimate 

	| total 	|
	tasks ifEmpty:[^0].
	total := tasks inject: 0 into:[ :tot :ea | tot + ea estimatedPts].
	^total			
! !

WAComponent subclass: #ViewDetailReport
	instanceVariableNames: 'report model items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Components'!

!ViewDetailReport methodsFor: 'initialization' stamp: 'RGA 11/23/2014 17:07'!
initialize

	super initialize .
	model := self session database project .
	
	! !

!ViewDetailReport methodsFor: 'rendering' stamp: 'RGA 11/23/2014 17:26'!
renderContentOn: html
	
		html div class: 'table'.
		html horizontalRule .
		html break .
		self renderTasksOn: html .! !

!ViewDetailReport methodsFor: 'rendering' stamp: 'RGA 11/23/2014 17:14'!
renderTask: aTask On: html
 
	html render: aTask hisName .
	html render: aTask estimatedPts. 
	html render: aTask owner.
	html render: aTask  donePts.
	html render: aTask status .
	html render: aTask useCase.! !

!ViewDetailReport methodsFor: 'rendering' stamp: 'RGA 11/24/2014 16:44'!
renderTasksOn: html
  
        model members isEmptyOrNil 
		ifFalse: [
			model members anyOne  tasks do: [ :task |
            	self renderTask: task On: html ]
		]! !

WAComponent subclass: #XpLoginComponent
	instanceVariableNames: 'email password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Login'!

!XpLoginComponent commentStamp: 'rga 3/19/2009 15:11' prior: 0!
A XpLoginComponent is xxxxxxxxx.

Instance Variables
	email:		<initialized in renderTextInputOn:>
	messageComponent:		<to inform the user of what is going on with the application>
	password:		<initialized in renderPasswordInputOn:>

email
	- xxxxx

messageComponent
	- xxxxx

password
	- xxxxx
!

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:08'!
email
	^ email! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 15:07'!
email: anObject

	email := anObject! !

!XpLoginComponent methodsFor: 'testing' stamp: 'rga 3/9/2009 16:47'!
hashPassword: aString

	aString
		ifEmpty: [^0]
		ifNotEmpty:[ ^ SecureHashAlgorithm  new hashMessage: aString]! !

!XpLoginComponent methodsFor: 'initialization' stamp: 'rga 3/19/2009 15:06'!
initialize

	super initialize.! !

!XpLoginComponent methodsFor: 'action' stamp: 'rga 3/20/2009 15:15'!
label

	^ 'S.V.P. Entrez votre adresse de courriel et votre mot de passe ...!!'! !

!XpLoginComponent methodsFor: 'action' stamp: 'rga 3/20/2009 16:44'!
loginFailed

	self messageComponent errorMessage: 'Login failed - - Please  retry !!'.
! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:14'!
messageComponent

	^ messageComponent ifNil:[ messageComponent := XpMessageComponent new]! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:16'!
messageComponent: aComponent

	 messageComponent := aComponent! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:08'!
password
	^ password! !

!XpLoginComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 15:08'!
password: anObject
	password := anObject! !

!XpLoginComponent methodsFor: 'action' stamp: 'rga 3/9/2009 16:49'!
registerUser

	self answer: #registerUser! !

!XpLoginComponent methodsFor: 'rendering' stamp: 'RGA 11/21/2014 11:29'!
renderContentOn: html 
	html div
		class: 'presentation';
		with: 
			[ self renderInviteOn: html.
			html 
				text: self label.
			html
				render: self messageComponent;
				form: 
					[ self
						renderTextInputOn: html;
						renderPasswordInputOn: html;
						renderLoginButtonOn: html;
						renderSignUpButtonOn: html ] ]! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 4/5/2009 21:54'!
renderInviteOn: html 
	html heading: XpLibrary applicationName.
	html div
		class: 'info';
		with: 
			[ html 
				text: XpLibrary info ].
! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 3/19/2009 12:10'!
renderLoginButtonOn: html

	html submitButton 
		callback: [ self validateLogin];
		text: 'Connexion'! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 3/9/2009 16:39'!
renderPasswordInputOn: html

	html passwordInput 
		callback:[ :value | self password:  (self hashPassword: value)];
		value: ''! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 4/2/2009 17:55'!
renderSignUpButtonOn: html 
	html
		break;
		break;
		break.
	html submitButton
		callback: [ self registerUser ];
		text: 'S''inscrire   ' , XpLibrary applicationName! !

!XpLoginComponent methodsFor: 'rendering-elements' stamp: 'rga 3/19/2009 12:14'!
renderTextInputOn: html

	html break .
	html textInput
		on: #email of: self;
		value: ''.
	html space ! !

!XpLoginComponent methodsFor: 'action' stamp: 'rga 3/20/2009 16:23'!
validateLogin

	| user |
	user := self session findUserByEmail: self email.
	(user notNil and: [user password = self password])
		ifTrue:[ self answer: user]
		ifFalse:[ self loginFailed ]! !

WAComponent subclass: #XpMenuComponent
	instanceVariableNames: 'currentMenu entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Components'!

!XpMenuComponent commentStamp: 'rga 2/27/2009 22:57' prior: 0!
A XPMenuComp is xxxxxxxxx.

Instance Variables
	currentMenu:		<Object>

currentMenu
	- keep the current selected menu item
!

!XpMenuComponent methodsFor: 'action' stamp: 'rga 2/27/2009 23:57'!
addEntry: aString withAction: aBlock
"Each entrie is an association key -> valu"
	^ self entries add: ( aString -> aBlock)! !

!XpMenuComponent methodsFor: 'accessing' stamp: 'rga 2/27/2009 23:18'!
entries
	^ entries! !

!XpMenuComponent methodsFor: 'initialization' stamp: 'rga 2/27/2009 23:16'!
initialize

	super initialize.
	entries := OrderedCollection new.! !

!XpMenuComponent methodsFor: 'rendering' stamp: 'rga 3/9/2009 12:32'!
renderContentOn: html

	self entries
			do:[ :entry | 
				html anchor
					callback: entry value ;
					with: entry key]
				separatedBy: [html space]! !

WAComponent subclass: #XpMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Login'!

!XpMessageComponent methodsFor: 'as yet unclassified' stamp: 'rga 3/20/2009 16:39'!
errorMessage: aString
	self
		messageString: 'Erreur: ' , aString ;
		messageType: 'error' ;
		wasShown: false.
! !

!XpMessageComponent methodsFor: 'as yet unclassified' stamp: 'rga 3/10/2009 09:53'!
infoMessage: aString
	self
		messageString: 'Info: ' , aString ;
		messageType: 'info' ;
		wasShown: false! !

!XpMessageComponent methodsFor: 'initialization' stamp: 'rga 3/10/2009 09:50'!
initialize

	super initialize.
	self wasShown: true! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
messageString
	^ messageString! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
messageString: anObject
	messageString := anObject! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
messageType
	^ messageType! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
messageType: anObject
	messageType := anObject! !

!XpMessageComponent methodsFor: 'rendering' stamp: 'rga 3/10/2009 09:54'!
renderContentOn: html

	self wasShown ifTrue: [ ^self].
	html div
		class: self messageType , 'Message' ;
		with: self messageString.! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
wasShown
	^ wasShown! !

!XpMessageComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:50'!
wasShown: anObject
	wasShown := anObject! !

WAComponent subclass: #XpProcessComponent
	instanceVariableNames: 'model parent verticalMenu horizontalMenu report editors associations detailReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Components'!

!XpProcessComponent commentStamp: 'RGA 11/21/2014 20:35' prior: 0!
A XPProcessComp is the main component of the application. .

Instance Variables
	model:		<Object>

model
	- an XPProject
!

!XpProcessComponent methodsFor: 'report' stamp: 'rga 12/22/2014 12:54'!
addCommandsOn: aReport 

	aReport
		addColumn: (MACommandColumn new
				addCommandOn: self
					selector: #editObject:
					text: 'diter';
				yourself);	  
		addColumn: (MACommandColumn new
				addCommandOn: self
					selector: #removeObject:
					text: 'Effacer';
				yourself); 
		addColumn: (MACommandColumn new
				addCommandOn: self
					selector: #detail: 
					text: 'Associations';
				yourself).! !

!XpProcessComponent methodsFor: 'editing-removing' stamp: 'rga 1/4/2015 03:53'!
addObject:  anObject

	| aSelector aCollection |
"	anObject removeSelf .
"
	anObject ifNotNil: [
		aSelector := anObject asSelector .
		aCollection := model perform: aSelector.
		(aCollection includes:anObject)
			ifFalse:[
				aCollection add: anObject.
				self save.]
			]! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'RGA 11/21/2014 20:35'!
associations
	^ associations! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'RGA 11/21/2014 20:35'!
associations: anObject
	associations := anObject! !

!XpProcessComponent methodsFor: 'report' stamp: 'rga 1/4/2015 03:59'!
buildReportFor: anObject 
	"Create a report for that kind of object"
	| aSelector |
	aSelector :=  anObject asSelector .
	^ self report  rows: (model perform: aSelector)
! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'RGA 11/22/2014 17:13'!
children

	^ Array  with:  verticalMenu  with:  report  with:  horizontalMenu with: detailReport
	! !

!XpProcessComponent methodsFor: 'creating' stamp: 'rga 12/20/2014 15:23'!
createNewCycle
	| answer  obj |
	self cyclesReport: model.
	obj := XpCycle new.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[
		self model addACycle:  answer .
		self cyclesReport: model.
		self save]! !

!XpProcessComponent methodsFor: 'creating' stamp: 'rga 1/4/2015 18:24'!
createNewMember
"Seaside version"
	| answer obj |
	self membersReport. 
	obj := XpMember new.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil: 
		[ "set the project of the XpMember object"
		model addAMember: answer.
		self membersReport .
		self save].! !

!XpProcessComponent methodsFor: 'creating' stamp: 'rga 12/20/2014 15:24'!
createNewRelease
		| answer  obj |
	" on appelle #releasesReport pour tre dans le bon contexte car les boutons de cration peuvent tre utiliss peut importe le rapport qui est affich."
	self releasesReport.
	obj := XpRelease  new.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[
		self model addARelease:  answer .
		self releasesReport.
		self save]! !

!XpProcessComponent methodsFor: 'creating' stamp: 'rga 12/20/2014 15:24'!
createNewTask
	
| answer  obj |
	
	self tasksReport: model.
	obj := XpTask new.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[ 
		self model addATask: answer .
		self tasksReport: model.
		self save].

! !

!XpProcessComponent methodsFor: 'creating' stamp: 'rga 12/20/2014 15:24'!
createNewTest
	
| answer  obj |
	self testsReport.
	obj := XpTest  new.
	answer := self call: (obj asComponent)  addValidatedForm.
	answer ifNotNil:[
		self model addATest: answer .
		self testsReport.
		self save]! !

!XpProcessComponent methodsFor: 'creating' stamp: 'rga 12/20/2014 15:24'!
createNewUseCase
| anAnswer  obj |
	self useCasesReport: model. 
	obj := XpUseCase  new.
	self flag: #revoir.
	" est-ce utile et ncessaire de conserver le projet dans tous les objects. Initialement c'tait
	pour faciliter l'accs au projet hors de XpProcessComponent. Est-ce encore requis!!"
	anAnswer := self call: (obj asComponent)  addValidatedForm.
	anAnswer ifNotNil:[ 		
		self model addAUseCase: anAnswer .
		self useCasesReport: model.
		self save]! !

!XpProcessComponent methodsFor: 'actions' stamp: 'RGA 11/24/2014 20:29'!
cssClassFor: anObject

	| myDesc |
	editors 
		at: anObject
		ifAbsentPut: [ anObject normalDescriptionPlusID ].
		myDesc cssClass: 'reportB'.
! !

!XpProcessComponent methodsFor: 'report' stamp: 'rga 1/6/2015 22:17'!
cyclesReport: anObject
	"We eliminate the field we dont want in our report, here it is :
	#note. See reject:"
	| choosedSelectors |

	choosedSelectors := XpCycle new  magritteDescription
				reject: [:each | #(#note ) includes: each accessor selector].
	anObject class = XpProject
		ifFalse:[
				self	detailReport:  (XpReport  rows: anObject cycles description: choosedSelectors).
				self detailReport title: (anObject projectName ) ,' -- Les Cycles de Dveloppement' ]
		ifTrue:[
			self report: (XpReport  rows: anObject cycles description: choosedSelectors).
			self report title: (anObject projectName ) ,' -- Les Cycles de Dveloppement' .
			self addCommandsOn: self report]! !

!XpProcessComponent methodsFor: 'editing-removing' stamp: 'rga 12/22/2014 12:56'!
detail: anObject 
	"We build a report only if anObject class is a member of associations "
	| kindOfReport nbItem aSelector |	
	^ (associations includesKey: anObject class)  
		ifTrue:[
			aSelector := associations at: anObject class.
			nbItem := aSelector size.
			1  to: nbItem   
				do: [:ea | 
					kindOfReport := aSelector at: ea.
					self report rows: (anObject perform: kindOfReport)]
			]

! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'RGA 11/22/2014 16:59'!
detailReport 
	^ detailReport ! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'RGA 11/22/2014 16:59'!
detailReport: aReport
	detailReport := aReport! !

!XpProcessComponent methodsFor: 'editing-removing' stamp: 'rga 12/18/2014 17:05'!
editObject: anObject 
	| myDesc component |
	myDesc := editors 
		at: anObject
		ifAbsentPut: [ anObject normalDescriptionPlusID ].
	myDesc cssClass: 'reportB'.
	component := (myDesc asComponentOn: anObject  ) addValidatedForm. 
	self show: component onAnswer: [ :answer |	
			self removeObject:  anObject.
			self addObject: anObject ].
	self buildReportFor: anObject.! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'RGA 11/21/2014 20:35'!
editors
	^ editors! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'RGA 11/21/2014 20:35'!
editors: anObject
	editors := anObject! !

!XpProcessComponent methodsFor: 'menu' stamp: 'rga 2/8/2010 15:06'!
horizontalMenu
	^ horizontalMenu! !

!XpProcessComponent methodsFor: 'menu' stamp: 'rga 2/8/2010 15:06'!
horizontalMenu: anObject
	horizontalMenu := anObject! !

!XpProcessComponent methodsFor: 'initialization' stamp: 'RGA 12/17/2014 00:44'!
initialize
"self initialize"
	super initialize.
	model := self session database project.
	ChronologyConstants initializeForFrench.
	editors := Dictionary new.
	associations := Dictionary new.
	self verticalMenu: XpMenuComponent new.
	self horizontalMenu: XpMenuComponent new.
	self
		initializeAssociations;
		initializingVerticalMenu;
		initializingHorizontalMenu;
		membersReport
	

! !

!XpProcessComponent methodsFor: 'initialization' stamp: 'RGA 11/28/2014 16:31'!
initializeAssociations
	associations at: XpMember  put: #(#tasks #useCases).
	associations at: XpRelease  put: #(#cycles).
	associations at: XpCycle  put: #(#useCases).
	associations at: XpUseCase put: #(#tests #tasks)
! !

!XpProcessComponent methodsFor: 'initialization' stamp: 'RGA 11/24/2014 19:26'!
initializingHorizontalMenu

	self horizontalMenu
			addEntry: 'Nouveau membre'
				withAction: [  self createNewMember  ];
			addEntry: 'Nouveau livrable'
				withAction: [  self createNewRelease  ];
			addEntry: 'Nouveau cycle de dveloppement'
				withAction: [  self createNewCycle   ];			
			addEntry: 'Nouveau cas'
				withAction: [  self createNewUseCase  ];
			addEntry: 'Nouvelle tche'
				withAction: [  self createNewTask  ];
			addEntry: 'Nouveau test'
				withAction: [  self createNewTest  ];
	
			addEntry: 'DCONNEXION'
				withAction: [ self session logout. self answer ];
			yourself! !

!XpProcessComponent methodsFor: 'initialization' stamp: 'RGA 11/24/2014 19:25'!
initializingVerticalMenu
	self verticalMenu
		addEntry: 'Membres'
			withAction: [ self membersReport ];
		addEntry: 'Livrables'
			withAction: [ self releasesReport ];
		addEntry: 'Cycles...'
			withAction: [ self cyclesReport: model ];
		addEntry: 'Cas...'
			withAction: [ self useCasesReport: model ];
		addEntry: 'Tches'
			withAction: [ self tasksReport: model ];
		addEntry: 'Tests'
			withAction: [ self testsReport ];
		yourself! !

!XpProcessComponent methodsFor: 'report' stamp: 'rga 1/7/2015 17:04'!
membersReport
	"We eliminate the fields we dont want
	in our report, here it is : email password endDate startDate
	note. See reject: below"
	| choosedSelectors |
	choosedSelectors := XpMember new magritteDescription
				reject: [:each | #(#email #password #end #startDate #note ) includes: each accessor selector].
	self
		report: (XpReport rows: model members description: choosedSelectors).
	self report title:  (model projectName  ) ,' -- Les Membres' .
	self addCommandsOn: self report.
! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 6/19/2009 15:01'!
model
"see initialization"
	^model! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'RGA 11/21/2014 20:35'!
model: anObject
	model := anObject! !

!XpProcessComponent methodsFor: 'editing-removing' stamp: 'RGA 11/28/2014 16:40'!
nilIifyAssociationsFor: anObject

	^( associations includesKey: anObject class )
		ifTrue:[associations at: anObject class ]! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 12:35'!
parent
	^ parent! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 3/9/2009 12:35'!
parent: anObject
	parent := anObject! !

!XpProcessComponent methodsFor: 'private' stamp: 'rga 1/3/2010 04:13'!
refreshReport
	self report rows: model members! !

!XpProcessComponent methodsFor: 'report' stamp: 'rga 1/6/2015 22:17'!
releasesReport
	| choosedSelectors |
	choosedSelectors := XpRelease new magritteDescription
				reject: [:each | #(#note ) includes: each accessor selector].
	self
		report: (XpReport rows: model releases description: choosedSelectors).
	self report title: model projectName , ' -- Les Livrables'.
	self addCommandsOn: self report! !

!XpProcessComponent methodsFor: 'editing-removing' stamp: 'rga 1/4/2015 03:57'!
removeObject:  anObject

	| aSelector aCollection cont |

	aSelector := anObject asSelector .
	aCollection := model perform: aSelector.
	(aCollection includes: anObject )
	ifTrue:[
		cont := self nilIifyAssociationsFor: anObject.
		aCollection remove: anObject.
		self save.]

	
	! !

!XpProcessComponent methodsFor: 'rendering' stamp: 'RGA 11/23/2014 17:25'!
renderContentOn: html 
	html div
		class: 'menu';
		with: [ html render: verticalMenu ].
	html div with: 
		[ html heading: 'L''utilisateur est : ' , self session user hisName capitalized.
		  html div
			class: 'menuCreation' ;
			with: [html render: horizontalMenu].
	html div
		class: 'center';
    		with: self report title.	  
	html render: self report].
	
	html div 
		class: 'table';
		with:[
			html render: ViewDetailReport new]


! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 3/22/2009 10:20'!
report
	^ report! !

!XpProcessComponent methodsFor: 'accessing' stamp: 'rga 3/22/2009 10:20'!
report: anObject
	report := anObject! !

!XpProcessComponent methodsFor: 'private' stamp: 'rga 1/6/2015 22:15'!
resetProject
	"To create aProject and to set a database properly. 
	The second time you send this message, your old database
	will be erase/replace by a new empty one. 
	To make a reset see XpRootTask #go"
	| aProject |
	aProject := XpProject new hisName: 'Second Projet'.
	self session database project: aProject.
	self session project: aProject.
	aProject maui openNewViewNamed: 'ProjectCollectionView'! !

!XpProcessComponent methodsFor: 'editing-removing' stamp: 'RGA 11/23/2014 15:36'!
save
	"Is it necessary to make a snapshot so often?
	"
	self flag: #revoir.
	self session database saveImage.
	self flag: #modifierSiMagma
! !

!XpProcessComponent methodsFor: 'actions' stamp: 'RGA 11/24/2014 20:29'!
setCssClassFor: anObject

	| myDesc |
	myDesc := editors 
		at: anObject
		ifAbsentPut: [ anObject normalDescriptionPlusID ].
		myDesc cssClass: 'reportB'.
! !

!XpProcessComponent methodsFor: 'report' stamp: 'rga 1/6/2015 22:18'!
tasksReport: anObject
	| choosedSelectors |

	choosedSelectors := XpTask new magritteDescription
				reject: [:each | #(#end #startDate #note #owner ) includes: each accessor selector].
	anObject class = XpProject
		ifFalse:[
			self detailReport: (XpReport rows: anObject tasks description: choosedSelectors).
			self detailReport title: (anObject projectName ), ' -- Les Tches']
		ifTrue:[
			self report: (XpReport rows: anObject tasks description: choosedSelectors).
			self report title: (anObject projectName ), ' -- Les Tches'.
			self addCommandsOn: self report]! !

!XpProcessComponent methodsFor: 'report' stamp: 'rga 1/6/2015 22:18'!
testsReport
	| choosedSelectors |

	choosedSelectors := XpTest new magritteDescription
				reject: [:each | #(#end #startDate #note ) includes: each accessor selector].
	self
		report: (XpReport rows: model tests description: choosedSelectors).
	self report title:  model projectName , ' -- Les Tests'  .
	self addCommandsOn: self report! !

!XpProcessComponent methodsFor: 'report' stamp: 'rga 1/6/2015 22:18'!
useCasesReport: anObject 
	| choosedSelectors |
	choosedSelectors := XpUseCase new magritteDescription
				reject: [:each | #(#startDate #end #note ) includes: each accessor selector].
	self
		report: (XpReport rows: anObject useCases description: choosedSelectors).
	self report title: anObject projectName , ' -- Les Cas d''Utilisation'.
	anObject class = XpProject
		ifTrue: [self addCommandsOn: self report]! !

!XpProcessComponent methodsFor: 'menu' stamp: 'rga 2/8/2010 15:05'!
verticalMenu
	^ verticalMenu! !

!XpProcessComponent methodsFor: 'menu' stamp: 'rga 2/8/2010 15:05'!
verticalMenu: anObject
	verticalMenu := anObject! !

WAComponent subclass: #XpRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Login'!

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:33'!
hashPassword: aString

	aString
		ifEmpty: [ ^ 0]
		ifNotEmpty:[ ^ SecureHashAlgorithm new hashMessage: aString]! !

!XpRegisterComponent methodsFor: 'initialization' stamp: 'rga 3/19/2009 12:37'!
initialize

	super initialize.
	self user: XpMember new! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:35'!
messageComponent

	^ messageComponent ifNil:[ 	messageComponent := XpMessageComponent new.]! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:35'!
messageComponent: anObject

	messageComponent := anObject! !

!XpRegisterComponent methodsFor: 'action' stamp: 'RGA 10/24/2014 10:34'!
registerUser
	self flag: #revoir.
	self user hisName isEmptyOrNil
		ifTrue:[ ^ self messageComponent
			infoMessage: 'S.V.P.  choisir un nom d''usager!!'].
	self user email isEmptyOrNil
		ifTrue:[ ^ self messageComponent
			infoMessage: 'S.V.P.  entrez votre courriel!!'].
	"(self session findUserByEmail: self user email)
		ifNotNil:[ ^ self messageComponent 
			errorMessage:' Cette adresse de courriel est dj inscrite!!']."
	self user password = 0
		ifTrue:[ ^ self messageComponent
			infoMessage: 'S.V.P.  choisir un mot de passe!!'].
	self user password = self repeatedPassword
		ifFalse:[ ^ self messageComponent
			infoMessage: 'Votre mot de passe rpt ne concorde pas!!']. 
	self session database addUser: self user.
	self answer: self user

! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/9/2009 17:12'!
renderCancelButtonOn: html

	html submitButton 
		callback: [ self answer: nil] ;
		text: 'Annuler'! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 4/3/2009 11:26'!
renderContentOn: html

	html div
		class: 'registerComponent';
		with:[
			html
				heading: 'Inscription' ;
				render: self messageComponent ;
				form: [
					html table: [
						self
							renderUserNameTextInputOn: html ;
							renderEmailTextInputOn: html ;
							renderPasswordTextInputOn: html ;
							renderRepeatedPasswordTextInputOn: html .
						html tableRow: [
							html
								tableData ;
								tableData:[ 
									self renderSubmitButtonOn: html.
									html space.
									self renderCancelButtonOn: html] ] ] ] ]! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/19/2009 12:41'!
renderEmailTextInputOn: html 

	html tableRow: [
		html
			tableData:  'Votre Courriel' ;
			tableData: [
				html textInput
					callback:[ :value | self user email: value ] ;
					value: self user email]]! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/19/2009 12:45'!
renderPasswordTextInputOn: html

	html tableRow: [
		html
			tableData:  'Mot de passe' ;
			tableData: [
				html passwordInput 
					callback:[ :value | 
						self user password: (self hashPassword: value)] ]]! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/19/2009 12:47'!
renderRepeatedPasswordTextInputOn: html

	html tableRow: [
		html
			tableData:  'Rpter votre mot de passe' ;
			tableData: [
				html passwordInput 
					callback:[ :value | 
						self  repeatedPassword: (self hashPassword: value)] ]]! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/9/2009 17:11'!
renderSubmitButtonOn: html

	html submitButton 
		callback:[ self registerUser] ;
		text: 'Inscrire'! !

!XpRegisterComponent methodsFor: 'rendering' stamp: 'rga 3/19/2009 11:05'!
renderUserNameTextInputOn: html

	html tableRow: [
		html
			tableData:  'Nom de l''usager' ; 
			tableData: [
				html textInput
					callback: [ :value | self user hisName: value] ;
					value: self user hisName]]! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:36'!
repeatedPassword

	^ repeatedPassword! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:36'!
repeatedPassword: anObject

	repeatedPassword := anObject! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:36'!
user

	^ user! !

!XpRegisterComponent methodsFor: 'accessing' stamp: 'rga 3/19/2009 12:36'!
user: anObject

	user := anObject! !

WASession subclass: #XpSession
	instanceVariableNames: 'user database project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Login'!

!XpSession methodsFor: 'accessing' stamp: 'rga 3/10/2009 10:38'!
database
	^ database! !

!XpSession methodsFor: 'accessing' stamp: 'rga 3/10/2009 10:38'!
database: anObject
	database := anObject! !

!XpSession methodsFor: 'accessing' stamp: 'rga 3/10/2009 10:37'!
findUserByEmail: eMail

	^ self  database findUserByEmail: eMail! !

!XpSession methodsFor: 'initialization' stamp: 'RGA 11/7/2014 18:57'!
initialize

	super initialize.
	self database: XpImageDB new.! !

!XpSession methodsFor: 'actions' stamp: 'rga 3/9/2009 14:40'!
isLoggedIn 

	^ self user notNil! !

!XpSession methodsFor: 'actions' stamp: 'rga 3/9/2009 14:38'!
login: aUser

	self user: aUser! !

!XpSession methodsFor: 'actions' stamp: 'rga 3/9/2009 14:39'!
logout 

	self user: nil! !

!XpSession methodsFor: 'accessing' stamp: 'RGA 10/29/2014 13:31'!
project
	^ project! !

!XpSession methodsFor: 'accessing' stamp: 'RGA 10/29/2014 13:30'!
project: anObject
	project := anObject! !

!XpSession methodsFor: 'initialization' stamp: 'rga 3/19/2009 09:19'!
responseForRequest: aRequest

	self database connectionFailed
		ifTrue: [ ^ WAResponse  new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!XpSession methodsFor: 'initialization' stamp: 'rga 3/18/2009 21:41'!
unregistered

	self database disconnect.
	super unregistered! !

!XpSession methodsFor: 'initialization' stamp: 'RGA 11/21/2014 10:51'!
updateRoot: anHtmlRoot 
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (XpLibrary urlOf: #xpCss)! !

!XpSession methodsFor: 'accessing' stamp: 'rga 3/9/2009 14:38'!
user
	^ user! !

!XpSession methodsFor: 'accessing' stamp: 'rga 3/9/2009 14:38'!
user: anObject
	user := anObject! !

Object subclass: #XpImageDB
	instanceVariableNames: ''
	classVariableNames: 'Users WriteMutex XpProjectData'
	poolDictionaries: ''
	category: 'XpProcess-Database'!

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/22/2009 09:51'!
project

	^ self xpProjectData! !

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/22/2009 09:53'!
project: aProject

	self xpProjectData: aProject! !

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/19/2009 11:31'!
reset

	Users := OrderedCollection new! !

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/18/2009 17:58'!
users

	^ Users ifNil: [ Users := OrderedCollection new ]! !

!XpImageDB class methodsFor: 'accessing' stamp: 'rga 3/18/2009 17:59'!
users: anObject

	 Users := anObject! !

!XpImageDB class methodsFor: 'private' stamp: 'rga 3/18/2009 17:59'!
writeMutex

	^ WriteMutex  ifNil: [ WriteMutex := Monitor new]! !

!XpImageDB class methodsFor: 'private' stamp: 'rga 3/18/2009 18:00'!
writeMutex: anObject

	WriteMutex := anObject! !

!XpImageDB class methodsFor: 'private' stamp: 'rga 3/22/2009 09:50'!
xpProjectData

	^ XpProjectData! !

!XpImageDB class methodsFor: 'private' stamp: 'rga 3/22/2009 09:50'!
xpProjectData: aProject

	XpProjectData := aProject! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 1/3/2010 04:13'!
addMember: aMember 
	self class members add: aMember.
	self saveImage.
	^ aMember! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 3/18/2009 18:05'!
addTask: aTask toUser: aUser

^ nil! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 3/18/2009 18:06'!
addUser: aUser
	self class users add: aUser.
	self saveImage.
	^ aUser! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 3/18/2009 18:05'!
addWork: aWork toUser: aUser

	aUser works: aWork.
	self saveImage.
	^aWork! !

!XpImageDB methodsFor: 'connection open/close' stamp: 'rga 3/18/2009 18:07'!
connectionFailed

	^ false! !

!XpImageDB methodsFor: 'connection open/close' stamp: 'rga 3/18/2009 18:07'!
disconnect

! !

!XpImageDB methodsFor: 'user management' stamp: 'rga 3/19/2009 11:19'!
findUserByEmail: aMail

	^ self  class users
		detect: [ :each | each email = aMail ] 
		ifNone:[ nil]! !

!XpImageDB methodsFor: 'initialize-release' stamp: 'RGA 10/28/2014 13:03'!
initialize
	super initialize.
! !

!XpImageDB methodsFor: 'lazzy-initialization' stamp: 'RGA 11/24/2014 17:33'!
project
	^ self class project
		ifNil: [self class
				project: (XpProject new hisName: 'Premier Projet')]! !

!XpImageDB methodsFor: 'accessing' stamp: 'rga 3/22/2009 09:53'!
project: aProject

	self class project: aProject! !

!XpImageDB methodsFor: 'connection open/close' stamp: 'rga 3/18/2009 18:10'!
reset

	self class reset! !

!XpImageDB methodsFor: 'saving' stamp: 'rga 3/18/2009 18:10'!
save: anObject! !

!XpImageDB methodsFor: 'saving' stamp: 'rga 3/18/2009 18:11'!
saveImage

	self class writeMutex critical: [ self saveImageWithoutMonitor]! !

!XpImageDB methodsFor: 'saving' stamp: 'rga 3/18/2009 18:12'!
saveImageWithoutMonitor

	SmalltalkImage current saveSession! !

Object subclass: #XpMagmaDB
	instanceVariableNames: 'session'
	classVariableNames: 'MagmaSession'
	poolDictionaries: ''
	category: 'XpProcess-Database'!

!XpMagmaDB methodsFor: 'user management' stamp: 'rga 3/10/2009 10:25'!
addUser: aUser

	self session commit: [ self users add: aUser].
	^ aUser! !

!XpMagmaDB methodsFor: 'stuff' stamp: 'rga 3/17/2009 18:32'!
connect

	self session: (MagmaSession
		host: self localhost
		port: self defaultPort).
	self session connectAs: 'aXpProcess'! !

!XpMagmaDB methodsFor: 'as yet unclassified' stamp: 'rga 3/10/2009 10:26'!
createUsers
	self session commit: [ self session root
		at: 'users'
		put: OrderedCollection new]! !

!XpMagmaDB methodsFor: 'defaults' stamp: 'rga 3/10/2009 10:21'!
defaultPort

	^ 51001! !

!XpMagmaDB methodsFor: 'connection open/close' stamp: 'rga 3/17/2009 22:19'!
disconnect

	self session 
		disconnect;
		closeRepository.
	self session: nil! !

!XpMagmaDB methodsFor: 'initialization' stamp: 'rga 3/10/2009 10:23'!
initialize

	self connect! !

!XpMagmaDB methodsFor: 'as yet unclassified' stamp: 'rga 3/17/2009 22:18'!
localHost

^ 'Macintosh.local '
"	^ #(127 0 0 1) asByteArray"! !

!XpMagmaDB methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:58'!
session
	^ session! !

!XpMagmaDB methodsFor: 'accessing' stamp: 'rga 3/10/2009 09:58'!
session: anObject
	session := anObject! !

!XpMagmaDB methodsFor: 'accessing' stamp: 'rga 3/10/2009 10:27'!
users

	^ self session root
		at: 'users'
		ifAbsent: [ self error: 'La Base de Donnes n''est pas initialise']! !

MAReport subclass: #XpReport
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Support'!

!XpReport commentStamp: 'RGA 11/22/2014 09:23' prior: 0!
XpReport is a subclass a MAReport that I created because I needed an instance variable that does not exist in MAReport

Instance Variables:
	title	<to give a title on each table >!

!XpReport methodsFor: 'accessing' stamp: 'RGA 11/20/2014 17:18'!
title
	^ title! !

!XpReport methodsFor: 'accessing' stamp: 'RGA 11/20/2014 17:18'!
title: anObject
	title := anObject! !

TestCase subclass: #XpCycleTest
	instanceVariableNames: 'project release aUseCase cycle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpCycleTest methodsFor: 'running' stamp: 'RGA 11/24/2014 20:08'!
setUp
	project := XpProject new.
	project newCycle.
	project newRelease.
	project newUseCase.
	aUseCase := project useCases last.
	cycle := project cycles last.
	release := project releases last! !

!XpCycleTest methodsFor: 'tests' stamp: 'rga 12/17/2014 14:35'!
testCycleHistory
	self assert: cycle history notEmpty.
	self assert: cycle end = project cycles last end.
	self assert: (cycle history last at:1) = Date today.! !

!XpCycleTest methodsFor: 'tests' stamp: 'rga 1/7/2015 18:03'!
testCycleLeftPts
	self assert: (cycle ucPtsLeft =( cycle ucLoad - cycle ucDonePts ))! !

!XpCycleTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 20:09'!
testCycleStates

	
	self assert: cycle hisName ='Sans nom'.
	self assert: cycle useCases notNil.
	self assert: cycle useCases isEmpty.
! !

!XpCycleTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 20:10'!
testCycleUseCases

	self assert: cycle useCases isEmpty.
	cycle useCases: aUseCase.
	self assert: (cycle useCases includes: aUseCase).
! !

!XpCycleTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 20:11'!
testCycleUseCasesRemoving
	| uCa |
	uCa := project newUseCase.
	self assert: (project useCases size = 2).
	self 
		assert: (project useCases includes: uCa).
	project useCases remove: uCa.
	self deny: (project useCases includes: uCa)! !

!XpCycleTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 20:11'!
testCyclesRemoving
	| aIter |
	aIter := project newCycle.
	self assert: (project cycles size = 2).
	self 
		assert: (project cycles
		includes: aIter).
	project cycles remove: aIter.
	self deny: (project cycles includes: aIter)! !

TestCase subclass: #XpMemberTest
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpMemberTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 1/3/2010 04:13'!
testMemberAdding
	| aMember bMember |
	aMember := project newMember.
	bMember := project newMember.
	self assert: (project members includes: aMember).
	self assert: (project members includes: bMember).
	self assert: project members size = 2! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 12/22/2014 12:32'!
testMemberPoints
	| aTask aMember bMember |
	project newMember.
	project newMember.
	aMember := project members first.
	bMember := project members last.
	project newTask.
	aTask := project tasks last.
	aTask donePts: 5.
	aTask estimatedPts: 7.
	project newTask.
	aTask := project tasks first.
	aTask donePts: 3.
	aTask estimatedPts: 9.
	self assert: aMember donePts = (aMember tskEstimate - aMember ptsLeft).
	self assert: aMember ptsLeft = (aMember tskEstimate - aMember donePts).
	self assert: bMember donePts = (bMember tskEstimate - bMember ptsLeft).
	self assert: bMember ptsLeft = (bMember tskEstimate - bMember donePts)! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:12'!
testMemberRemoving
	| aMember bMember |
	project
		newMember;
		newMember.
	aMember := project members first.
	bMember := project members last.
	project removeMember: aMember.
	self assert: project members size = 1.
	self 
		assert: (project oldMembers includes: aMember).
	self deny: (project members includes: aMember).
	self assert: (project members includes: bMember)! !

!XpMemberTest methodsFor: 'tests' stamp: 'RGA 11/23/2014 19:38'!
testMemberStates
	| aMember bMember |
	project
		newMember;
		newMember.
	aMember := project members first.
	bMember := project members last.
	self assert: aMember hisName = aMember defaultName.
	self assert: bMember role = aMember defaultRole.
	self assert: aMember note = aMember defaultNote.
	self assert: bMember project isNil .
	self assert: aMember email notNil.
	self assert: bMember password notNil! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 2/25/2009 11:16'!
testMemberTasksAssigned

	 | aMember bMember firstTask secondTask |
	aMember := project newMember.
	bMember := project newMember.
	firstTask := project newTask.
	secondTask := project newTask.
	aMember tasks: firstTask.
	aMember tasks: secondTask.
	self assert: aMember tasks size =2.
	self assert: bMember tasks isEmpty.! !

!XpMemberTest methodsFor: 'tests' stamp: 'rga 2/25/2009 11:19'!
testMemberUseCasesAssigned

	 | aMember bMember   aUCase bUCase |
	aMember := project newMember.
	bMember := project newMember.
	aUCase := project newUseCase.
	bUCase := project newUseCase.
	aMember useCases: aUCase.
	aMember useCases: bUCase.
	self assert: aMember useCases size =2.
	self assert: bMember useCases isEmpty.! !

TestCase subclass: #XpProjectTest
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpProjectTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 1/5/2015 13:09'!
testListCyclesNames
	| aIter bIter namesList |
	project newCycle ; newCycle ; newCycle.
	aIter := project cycles first.
	bIter := project cycles last.
	aIter hisName: 'Livrable-1'.
	bIter hisName: 'Livrable-2'.
	namesList := project namesOfThisCollection: project cycles.
	self assert: namesList size = 3.
	self 
		assert: (namesList
		includes: bIter hisName).
	self 
		assert: (namesList
		includes: aIter hisName).
	self 
		assert: (namesList
		includes: 'Sans nom')! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 1/5/2015 13:09'!
testListMembersNames
	| aMember bMember namesList |
	project
		newMember;
		newMember;
		newMember.
	aMember := project members first.
	aMember hisName: 'Joseph'.
	bMember := project members last.
	bMember hisName: 'Pauline'.
	namesList := project namesOfThisCollection: project members.
	self assert: namesList size = 3.
	self 
		assert: (namesList includes: bMember hisName).
	self 
		assert: (namesList
		includes: aMember hisName).
	self 
		assert: (namesList
		includes: 'Sans nom')! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 1/5/2015 13:09'!
testListReleasesNames
	| aRelease bRelease namesList |
	project newRelease ; newRelease ; newRelease.
	aRelease := project releases first.
	aRelease hisName: 'Livrable-1'.
	bRelease := project releases last.
	bRelease hisName: 'Livrable-2'.
	namesList := project namesOfThisCollection: project releases.
	self assert: namesList size = 3.
	self assert: (namesList  includes: bRelease hisName).
	self assert: (namesList includes: aRelease hisName).
	self assert: (namesList includes: 'Sans nom')! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 1/5/2015 13:09'!
testListTasksNames
	| aTask bTask namesList |
	project newTask ; newTask ; newTask.
	aTask := project tasks first.
	aTask hisName: 'T1'.
	bTask := project tasks last.
	bTask hisName: 'T2'.
	namesList := project namesOfThisCollection: project tasks.
	self assert: namesList size =3.
	self assert: (namesList includes: bTask hisName).
	self assert: (namesList includes: aTask hisName).
	self assert: (namesList includes: 'Sans nom').
! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 1/5/2015 13:09'!
testListTests
	| aTest bTest namesList |
	project newTest ; newTest; newTest.
	aTest := project tests first.
	aTest hisName: 'Test-1'.
	bTest := project tests last.
	bTest hisName: 'Test-2'.
	namesList := project namesOfThisCollection: project tests.
	self assert: namesList size = 3.
	self 
		assert: (namesList includes: bTest hisName).
	self 
		assert: (namesList includes: aTest hisName).
	self 
		assert: (namesList includes: 'Sans nom')! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 1/5/2015 13:09'!
testListUseCases
	| aUCase bUCase namesList  |
	project newUseCase ; newUseCase ; newUseCase.
	aUCase := project useCases first.
	aUCase hisName: 'Ouvrir un fichier'.
	bUCase := project useCases last.
	bUCase hisName: 'Sauvegarder la base'.
	namesList := project namesOfThisCollection: project useCases.
	self assert: namesList size = 3.
	self 
		assert: (namesList includes: bUCase hisName).
	self 
		assert: (namesList includes: aUCase hisName).
	self 
		assert: (namesList includes: 'Sans nom').! !

!XpProjectTest methodsFor: 'tests' stamp: 'RGA 11/7/2014 17:50'!
testMemberFinding
	| fMemberName aMember bMember |
	project
		newMember;
		newMember.
	aMember := project members first.
	aMember hisName: 'Joseph'.
	bMember := project members last.
	bMember hisName: 'Pauline'.
	fMemberName := project find: bMember  byName: bMember hisName.
	self assert: fMemberName notNil.
	self deny: aMember = fMemberName.
	self assert: bMember = fMemberName.
	self assert: project members size = 2! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 12/17/2014 14:35'!
testProjectStates
	| instVars |
	instVars := #(
		'id'
		'hisName'
		'owner'
		'note'
		'project'
		'startDate'
		#end
		'history'
		'useCases'
		'tasks'
		'tests'
		'releases'
		'cycles'
		'iterations'
		'oldMembers'
		'members'
		'aCase'
	).
	self assert: project hisName = 'Sans nom' .
	self assert: project startDate = Date today.
	self assert: project useCases isEmpty.
	self assert: project members isEmpty.
	self assert: project oldMembers isEmpty.
	self assert: project tasks isEmpty.
	self assert: project tests isEmpty.
	self assert: project releases isEmpty.
	self assert: project cycles isEmpty.
	self assert: project iterations isEmpty.
	self assert: instVars size = project class allInstVarNames size.
	self assert: project end = '1 janvier 1902' asDate
! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/23/2009 15:15'!
testProjectTasksFinding
	| firstTask secondTask foundTask aName |
	project newTask ; newTask.
	firstTask := project tasks first.
	secondTask := project tasks second.
	aName := 'The first one'.
	firstTask hisName: aName.
	secondTask hisName: 'The second one'.
	self assert: project tasks size = 2.
	self assert: project tasks first = firstTask.
	self assert: project tasks second = secondTask.
	foundTask := project findTask: firstTask.
	self assert: foundTask notNil.
	self assert: foundTask hisName = aName! !

!XpProjectTest methodsFor: 'tests' stamp: 'rga 2/23/2009 16:28'!
testProjectUseCaseFinding
	| firstCase secondCase aName foundCase |
	project newUseCase ; newUseCase.
	firstCase := project useCases first.
	secondCase := project useCases second.
	aName := 'The first one'.
	firstCase hisName: aName.
	secondCase hisName: 'The second one'.
	self assert: project useCases size = 2.
	self assert: project useCases first = firstCase.
	self assert: project useCases second = secondCase.
	foundCase := project findUseCase: firstCase.
	self assert: foundCase notNil.
	self assert: foundCase hisName = aName! !

TestCase subclass: #XpReleaseTest
	instanceVariableNames: 'project myRelease myUseCase myCycle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpReleaseTest methodsFor: 'running' stamp: 'RGA 11/24/2014 20:15'!
setUp
	project := XpProject new.
	project
		newRelease;
		newCycle;
		newUseCase.
	myRelease := project releases first.
	"	myRelease endDate: Date today.
"
	myCycle := project cycles first.
	myUseCase := project useCases first! !

!XpReleaseTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 11:40'!
testReleaseAssociations
"	| aProjectRelease |
	myIteration release: myRelease.
	self assert: myIteration release = myRelease.
	aProjectRelease := project releases anyOne.
	self assert: (aProjectRelease iterations includes: myIteration).
	myUseCase iteration: myIteration.
	self assert: myIteration useCases notEmpty.
	self assert: (myIteration useCases includes: myUseCase).
"! !

!XpReleaseTest methodsFor: 'running' stamp: 'RGA 11/24/2014 20:14'!
testReleaseCycleRemoving


	| aRel aIter bIter |
	aRel := project newRelease.
	aIter := project newCycle.
	bIter := project newCycle.
	aRel cycles: aIter.
	aRel cycles: bIter.
	self assert: (aRel cycles includes: bIter).
	self assert: aRel cycles size =2.
	aRel removeCycle: bIter.
	self deny: (aRel cycles includes: bIter)
! !

!XpReleaseTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 20:15'!
testReleaseDonePts

	| bUCase aTask bTask |
	aTask := project newTask.
	bTask := project newTask.
	aTask donePts: 2.
	bTask donePts: 4.
	aTask estimatedPts: 8.
	bTask estimatedPts: 10.
	bUCase := project newUseCase.
	myUseCase estimatedPts: 8.
	myUseCase tasks: aTask.
	bUCase estimatedPts: 5.
	bUCase tasks: bTask.
	myCycle useCases: myUseCase.	
	myCycle useCases: bUCase.
	myRelease cycles: myCycle.
	self assert: myRelease donePts =6! !

!XpReleaseTest methodsFor: 'tests' stamp: 'rga 12/17/2014 14:35'!
testReleaseHistory
	self assert: myRelease history notEmpty.
	self assert: myRelease end = project releases last end.
	self assert: (myRelease history last at:1) = Date today.! !

!XpReleaseTest methodsFor: 'tests' stamp: 'rga 1/7/2015 18:16'!
testReleaseLoad

	| bUCase aTask bTask |
	aTask := project newTask.
	bTask := project newTask.
	aTask donePts: 2.
	bTask donePts: 4.
	aTask estimatedPts: 8.
	bTask estimatedPts: 10.
	bUCase := project newUseCase.
	myUseCase estimatedPts: 8.
	myUseCase tasks: aTask.
	bUCase estimatedPts: 5.
	bUCase tasks: bTask.
	myCycle useCases: myUseCase.	
	myCycle useCases: bUCase.
	myRelease cycles: myCycle.
	" release load = estimatedPts of allUseCases of allIteration composing a release"
	self assert: myRelease cyclesUcLoad =13! !

!XpReleaseTest methodsFor: 'running' stamp: 'rga 2/25/2010 22:18'!
testReleaseRemoving


	| aRel |
	aRel := project newRelease.
	self assert: project releases size = 2.
	self assert: (project releases includes: aRel).
	project releases remove: aRel.
	self deny: (project releases includes: aRel).! !

!XpReleaseTest methodsFor: 'tests' stamp: 'rga 1/7/2015 17:48'!
testReleaseStates
	| projectRelease   |
	myRelease capacityPts: 23.
	self assert: project releases notEmpty.
	projectRelease := project releases anyOne.
	self assert: myRelease hisName = 'Sans nom'.
	self assert: projectRelease hisName = 'Sans nom'.
	self assert: projectRelease = myRelease.
	self assert: projectRelease cycles notNil.
	self assert: projectRelease cyclesCapacityPts = myRelease cyclesCapacityPts.
	self assert: myRelease project isNil ! !

TestCase subclass: #XpTaskTest
	instanceVariableNames: 'project firstTask secondTask thirdTask uCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpTaskTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new.
	project
		newTask;
		newTask;
		newUseCase.
	firstTask := project tasks first.
	secondTask := project tasks second.
	uCase := project useCases anyOne! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 2/24/2009 17:22'!
testTaskCreationDelete

	firstTask  hisName: 'The first one'.
	secondTask hisName: 'The second one'.
	self assert: project tasks size = 2.
	self assert: project tasks first = firstTask.
	self assert: project tasks second = secondTask.
	project tasks remove: firstTask.
	self assert: project tasks size = 1.
	self deny: (project tasks includes: firstTask)! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 12/17/2014 14:35'!
testTaskHistory
	self assert: firstTask history notEmpty.
	self assert: firstTask end = project tasks last end.
	self assert: (firstTask history last at:1) = Date today.! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 2/24/2009 17:22'!
testTaskPts

	secondTask estimatedPts: 5.
	self assert: firstTask  estimatedPts = 0.
	self assert: secondTask estimatedPts = 5.
	self assert: firstTask donePts = 0.
! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 12/17/2014 14:40'!
testTaskStatus
	
	project newTask.
	thirdTask  := project tasks last.
	secondTask startDate: Date yesterday.
	thirdTask startDate: Date yesterday.
	thirdTask end: Date tomorrow.
	"Date new is  1 January 1901 "
	self assert: project tasks first startDate =project tasks first defaultStartDate.
	self assert: project tasks first end = project tasks first defaultEndDate.	
	self assert: project tasks first status = 'To-Do'.
	self deny:  project tasks second startDate = Date new.
	self assert: project tasks second status = 'In-Progress'.
	self deny: project tasks third startDate = Date new.
	self deny: project tasks third end = Date new.
	self assert: project tasks third status = 'Done'.

! !

!XpTaskTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:19'!
testTaskUseCaseAssociation

	firstTask useCase: uCase.
	uCase owner = firstTask owner.
	self assert: firstTask useCase  = uCase.
	self assert: (project useCases includes: uCase).! !

TestCase subclass: #XpTestTest
	instanceVariableNames: 'project firstTest secondTest uCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpTestTest methodsFor: 'running' stamp: 'rga 3/9/2009 13:27'!
setUp
	project := XpProject new.
	uCase := project newUseCase! !

!XpTestTest methodsFor: 'tests' stamp: 'rga 2/24/2009 17:46'!
testTestAdding

	project newTest ; newTest.
	firstTest := project tests first.
	secondTest := project tests last.
	self assert: (project tests includes: firstTest).
	self assert: (project tests includes: secondTest)! !

!XpTestTest methodsFor: 'tests' stamp: 'rga 12/17/2014 14:35'!
testTestHistory

	firstTest := project newTest.	
	self assert: firstTest history notEmpty.
	self assert: firstTest end = project tests last end.
	self assert: (firstTest history last at:1) = Date today.! !

!XpTestTest methodsFor: 'tests' stamp: 'rga 2/20/2009 17:45'!
testTestRemoving

	project newTest ; newTest.
	firstTest := project tests first.
	secondTest := project tests last.
	project removeTest: firstTest.
	self assert: (project tests size = 1).
	self deny: (project tests includes: firstTest).
	self assert: (project tests includes: secondTest)! !

!XpTestTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:26'!
testTestStatus

	| stats |
	project newTest.
	firstTest := project tests anyOne.
	stats := project tests anyOne allStatus.
	self assert: (project tests includes: firstTest).
	self assert: (firstTest status = 'Not-Passed').
	self assert: (stats includes: 'Not-Passed').
	self assert: (stats includes: 'Passed').! !

!XpTestTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 11:51'!
testTestUseCaseAssociation

	project newTest.
	firstTest := project tests anyOne.
	self assert: project useCases notEmpty.
	self assert: firstTest useCase = nil.
	self assert: uCase tests isEmpty.
	firstTest useCase: uCase .
	uCase tests: firstTest.
	self assert: firstTest useCase notNil.
	self assert: (uCase tests includes: firstTest).! !

TestCase subclass: #XpUseCaseTest
	instanceVariableNames: 'project allPriorities allRisks useCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XpProcess-Tests'!

!XpUseCaseTest methodsFor: 'running' stamp: 'RGA 11/24/2014 19:38'!
setUp
	allPriorities := #('Must-Have' 'Should-Have' 'Could-Have' ).
	allRisks := #('High' 'Medium' 'Low' ).
	project := XpProject new.
	project
		newUseCase;
		newMember;
		newCycle.
	useCase := project useCases anyOne! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 20:16'!
testUseCaseCycle
"	| iteration |
	iteration := project iterations anyOne.
	useCase iteration: iteration.
	self assert: useCase iteration notNil.
	self
		assert: (iteration useCases includes: useCase)"! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 1/7/2015 18:21'!
testUseCaseDonePts

	| aTask bTask |
	aTask := project newTask.
	bTask := project newTask.
	aTask donePts: 2.
	bTask donePts: 4.
	aTask estimatedPts: 8.
	bTask estimatedPts: 10.
	useCase estimatedPts: 8.
	useCase tasks: aTask.
	useCase tasks: bTask.
	self assert: useCase tskDonePts =6! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 12/17/2014 14:35'!
testUseCaseHistory

	self assert: useCase history notEmpty.
	self assert: useCase end = project useCases last end.
	self assert: (useCase history last at:1) = Date today.! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 12/22/2014 12:34'!
testUseCaseLoad

	| aTask bTask |
	aTask := project newTask.
	bTask := project newTask.
	aTask donePts: 2.
	bTask donePts: 4.
	aTask estimatedPts: 8.
	bTask estimatedPts: 10.
	useCase estimatedPts: 8.
	useCase tasks: aTask.
	useCase tasks: bTask.
	self assert: useCase tskEstimate =18! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 12:33'!
testUseCaseOwner
"	
	
	self assert: useCase owner hisName = useCase owner  defaultName.
	useCase owner: (project members anyOne).
	self assert: useCase owner notNil.
	self assert: useCase owner hisName = useCase owner  defaultName.
	
"! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'RGA 11/24/2014 11:57'!
testUseCasePrioritiesAndRisks

	useCase priority: (allPriorities at: 1).
	useCase risk:( allRisks at: 1).
	self assert: (useCase risk = 'High').
	self assert: (useCase priority = 'Must-Have').
	self assert: (allRisks includes: 'Medium').
	self assert: (allRisks includes: 'Low').
	self assert: useCase risk = 'High'.
	self assert: useCase priority = 'Must-Have'.
	self assert: (allPriorities includes: 'Should-Have').
	self assert: (allPriorities includes: 'Could-Have').! !

!XpUseCaseTest methodsFor: 'tests' stamp: 'rga 2/25/2010 22:28'!
testUseCaseRemoving
	| bCase |
	bCase := project newUseCase.
	self assert: project useCases size = 2.
	self assert: (project useCases includes: bCase).
	project useCases remove: bCase.
	self deny: (project useCases includes: bCase)! !
XpRootTask initialize!
